{***********************************************************************}

{FileName  : cpwintypes.inc                                             }

{Version*  : .1                                                         }

{Author(s) : Andrew Johnson <AJ_Genius@Hotmail.com>                     }

{***********************************************************************}

{Comments : The Initial contents of this file were as taken from        } 

{  windows/wininc/base.inc in the FreePascal RTL, and as such fall under}

{  the same copyright license(LGPL : See Below).                        }

{***********************************************************************}

{*See end of file for history                                           } 

{***********************************************************************}



{

    $Id: cpwintypes.inc,v 1.1.1.1 2001/09/07 21:03:44 aj_genius Exp $

    This  file is part of the Free Pascal run time library.

    This unit contains base definition for the Win32 API

    Copyright (c) 1999-2000 by Florian Klaempfl,

    member of the Free Pascal development team.



    See the file COPYING.FPC, included in this distribution,

    for details about the copyright.



    This program is distributed in the hope that it will be useful,

    but WITHOUT ANY WARRANTY; without even the implied warranty of

    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.



 **********************************************************************}



{

  Base.h



  Base definitions



  Copyright (C) 1996, 1997 Free Software Foundation, Inc.



  Author: Scott Christley <scottc@net-community.com>



  This file is part of the Windows32 API Library.



  This library is free software; you can redistribute it and/or

  modify it under the terms of the GNU Library General Public

  License as published by the Free Software Foundation; either

  version 2 of the License, or (at your option) any later version.



  This library is distributed in the hope that it will be useful,

  but WITHOUT ANY WARRANTY; without even the implied warranty of

  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU

  Library General Public License for more details.



  If you are interested in a warranty or support for this source code,

  contact Scott Christley <scottc@net-community.com> for more information.



  You should have received a copy of the GNU Library General Public

  License along with this library; see the file COPYING.LIB.

  If not, write to the Free Software Foundation,

  59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

}

{$IfDef FPC}

  {$PACKRECORDS C}

{$EndIf}



  const

     NULL = nil;



  type

     ATOM = word;



     WINBOOL = longbool;

     BOOL = WINBOOL;



     CALTYPE = cardinal;

     CALID = cardinal;



     CCHAR = char;



     COLORREF = cardinal;

     TCOLORREF = cardinal;



     SHORT = integer;

     INT   = longint;

     WINT  = longint;

     LONG  = longint;

     DWORD = cardinal;

     LOWORD = DWORD;

     PINTEGER = ^longint;



     LONGLONG  = double;

     PLONGLONG = ^LONGLONG;



     DWORDLONG  = double;  { was unsigned long  }

     PDWORDLONG = ^DWORDLONG;



     FLOAT = real;



     HANDLE = longint;    { or should it be cardinal ?? PM }



     HACCEL = HANDLE;

     HBITMAP = HANDLE;

     HBRUSH = HANDLE;

     HCOLORSPACE = HANDLE;

     HCONV = HANDLE;

     HCONVLIST = HANDLE;

     HCURSOR = HANDLE;

     HDBC = HANDLE;

     HDC = HANDLE;

     HDDEDATA = HANDLE;

     HDESK = HANDLE;

     HDROP = HANDLE;

     HDWP = HANDLE;

     HENHMETAFILE = HANDLE;

     HENV = HANDLE;

     HFILE = HANDLE;

     HFONT = HANDLE;

     HGDIOBJ = HANDLE;

     HGLOBAL = HANDLE;

     HGLRC = HANDLE;

     HHOOK = HANDLE;

     HICON = HANDLE;

     HIMAGELIST = HANDLE;

     HINST = HANDLE;   { Not HINSTANCE, else it has problems with the var HInstance }

     HKEY = HANDLE;

     HKL = HANDLE;

     HLOCAL = HANDLE;

     HMENU = HANDLE;

     HMETAFILE = HANDLE;

     HMODULE = HANDLE;

     HPALETTE = HANDLE;

     HPEN = HANDLE;

     HRASCONN = HANDLE;

     HRESULT = HANDLE;

     HRGN = HANDLE;

     HRSRC = HANDLE;

     HSTMT = HANDLE;

     HSZ = HANDLE;

     HWINSTA = HANDLE;

     HWND = HANDLE;



     LANGID = word;

     LCID   = DWORD;

     LCTYPE = DWORD;

     LPARAM = longint;



     LP     = ^word;

     LPBOOL = ^WINBOOL;

     LPBYTE = ^BYTE;

     LPCCH  = PCHAR;

     LPCH   = PCHAR;



     LPCOLORREF = ^COLORREF;



     LPCSTR  = Pchar;

{$ifdef UNICODE}

     LPCTSTR = ^word;

{$else}

     LPCTSTR = Pchar;

{$endif}



     LPCWCH  = ^word;

     LPCWSTR = ^word;



     LPDWORD = ^DWORD;



     LPHANDLE = ^HANDLE;



     LPINT  = ^longint;

     LPLONG = ^longint;



     LPSTR = Pchar;

{$ifdef UNICODE}

     LPTCH  = ^word;

     LPTSTR = ^word;

{$else}

     LPTCH  = Pchar;

     LPTSTR = Pchar;

{$endif}



     LRESULT = longint;



     LPVOID  = pointer;

     LPCVOID = pointer;



     LPWCH  = ^word;

     LPWORD = ^word;

     LPWSTR = ^word;

     NWPSTR = ^word;



     PWINBOOL = ^WINBOOL;

     PBOOLEAN = ^BYTE;



     PBYTE = ^BYTE;



     PCCH = PCHAR;

     PCH  = PCHAR;



     PCSTR = Pchar;



     PCWCH  = ^word;

     PCWSTR = ^word;



     PDWORD = ^DWORD;



     PFLOAT = ^real;



     PHANDLE = ^HANDLE;

     PHKEY = ^HKEY;



     PINT = ^longint;

     PLONG = ^longint;

     PSHORT = ^integer;



     PSTR = Pchar;



     PSZ = Pchar;

{$ifdef UNICODE}

     PTBYTE = ^word;

     PTCH = ^word;

     PTCHAR = ^word;

     PTSTR = ^word;

{$else}

     PTBYTE = ^byte;

     PTCH   = Pchar;

     PTCHAR = Pchar;

     PTSTR  = Pchar;

{$endif}



     PUCHAR = ^byte;

     PWCH   = ^word;

     PWCHAR = ^word;



     PWORD   = ^word;

     PUINT   = ^cardinal;

     PULONG  = ^cardinal;

     PUSHORT = ^word;



     PVOID = pointer;



     RETCODE = integer;



     SC_HANDLE = HANDLE;

     SC_LOCK = LPVOID;

     LPSC_HANDLE = ^SC_HANDLE;



     SERVICE_STATUS_HANDLE = DWORD;



{$ifdef UNICODE}

     TBYTE = word;

     TCHAR = word;

     BCHAR = word;

{$else}

     TBYTE = byte;

     TCHAR = char;

     BCHAR = BYTE;

{$endif}



     UCHAR = byte;

     WCHAR = word;



     UINT   = cardinal;

     ULONG  = cardinal;

     USHORT = word;



     WPARAM = cardinal;



     FARPROC = pointer;



     PROC = FARPROC;



     SYSTEMTIME = record

          wYear : WORD;

          wMonth : WORD;

          wDayOfWeek : WORD;

          wDay : WORD;

          wHour : WORD;

          wMinute : WORD;

          wSecond : WORD;

          wMilliseconds : WORD;

       end;

     LPSYSTEMTIME = ^SYSTEMTIME;

     _SYSTEMTIME = SYSTEMTIME;

     TSYSTEMTIME = SYSTEMTIME;

     PSYSTEMTIME = ^SYSTEMTIME;

{***********************************************************************}

{   The following is taken from windows/wininc/messages.inc             }

{***********************************************************************}

Const

  { Window messages  }

     WM_ACTIVATE = 6;

     WM_ACTIVATEAPP = 28;

     WM_ASKCBFORMATNAME = 780;

     WM_CANCELJOURNAL = 75;

     WM_CANCELMODE = 31;

     WM_CAPTURECHANGED = 533;

     WM_CHANGECBCHAIN = 781;

     WM_CHAR = 258;

     WM_CHARTOITEM = 47;

     WM_CHILDACTIVATE = 34;

     WM_CHOOSEFONT_GETLOGFONT = 1025;

     WM_CHOOSEFONT_SETLOGFONT = 1125;

     WM_CHOOSEFONT_SETFLAGS = 1126;

     WM_CLEAR = 771;

     WM_CLOSE = 16;

     WM_COMMAND = 273;

     WM_COMPACTING = 65;

     WM_COMPAREITEM = 57;

     WM_CONTEXTMENU = 123;

     WM_COPY = 769;

     WM_COPYDATA = 74;

     WM_CREATE = 1;

     WM_CTLCOLORBTN = 309;

     WM_CTLCOLORDLG = 310;

     WM_CTLCOLOREDIT = 307;

     WM_CTLCOLORLISTBOX = 308;

     WM_CTLCOLORMSGBOX = 306;

     WM_CTLCOLORSCROLLBAR = 311;

     WM_CTLCOLORSTATIC = 312;

     WM_CUT = 768;

     WM_DEADCHAR = 259;

     WM_DELETEITEM = 45;

     WM_DESTROY = 2;

     WM_DESTROYCLIPBOARD = 775;

     WM_DEVICECHANGE = 537;

     WM_DEVMODECHANGE = 27;

     WM_DISPLAYCHANGE = 126;

     WM_DRAWCLIPBOARD = 776;

     WM_DRAWITEM = 43;

     WM_DROPFILES = 563;

     WM_ENABLE = 10;

     WM_ENDSESSION = 22;

     WM_ENTERIDLE = 289;

     WM_ENTERMENULOOP = 529;

     WM_ENTERSIZEMOVE = 561;

     WM_ERASEBKGND = 20;

     WM_EXITMENULOOP = 530;

     WM_EXITSIZEMOVE = 562;

     WM_FONTCHANGE = 29;

     WM_GETDLGCODE = 135;

     WM_GETFONT = 49;

     WM_GETHOTKEY = 51;

     WM_GETICON = 127;

     WM_GETMINMAXINFO = 36;

     WM_GETTEXT = 13;

     WM_GETTEXTLENGTH = 14;

     WM_HELP = 83;

     WM_HOTKEY = 786;

     WM_HSCROLL = 276;

     WM_HSCROLLCLIPBOARD = 782;

     WM_ICONERASEBKGND = 39;

     WM_IME_CHAR = 646;

     WM_IME_COMPOSITION = 271;

     WM_IME_COMPOSITIONFULL = 644;

     WM_IME_CONTROL = 643;

     WM_IME_ENDCOMPOSITION = 270;

     WM_IME_KEYDOWN = 656;

     WM_IME_KEYUP = 657;

     WM_IME_NOTIFY = 642;

     WM_IME_SELECT = 645;

     WM_IME_SETCONTEXT = 641;

     WM_IME_STARTCOMPOSITION = 269;

     WM_INITDIALOG = 272;

     WM_INITMENU = 278;

     WM_INITMENUPOPUP = 279;

     WM_INPUTLANGCHANGE = 81;

     WM_INPUTLANGCHANGEREQUEST = 80;

     WM_KEYDOWN = 256;

     WM_KEYUP = 257;

     WM_KILLFOCUS = 8;

     WM_LBUTTONDBLCLK = 515;

     WM_LBUTTONDOWN = 513;

     WM_LBUTTONUP = 514;

     WM_MBUTTONDBLCLK = 521;

     WM_MBUTTONDOWN = 519;

     WM_MBUTTONUP = 520;

     WM_MDIACTIVATE = 546;

     WM_MDICASCADE = 551;

     WM_MDICREATE = 544;

     WM_MDIDESTROY = 545;

     WM_MDIGETACTIVE = 553;

     WM_MDIICONARRANGE = 552;

     WM_MDIMAXIMIZE = 549;

     WM_MDINEXT = 548;

     WM_MDIREFRESHMENU = 564;

     WM_MDIRESTORE = 547;

     WM_MDISETMENU = 560;

     WM_MDITILE = 550;

     WM_MEASUREITEM = 44;

     WM_MENUCHAR = 288;

     WM_MENUSELECT = 287;

     WM_MOUSEACTIVATE = 33;

     WM_MOUSEMOVE = 512;

     WM_MOVE = 3;

     WM_MOVING = 534;

     WM_NCACTIVATE = 134;

     WM_NCCALCSIZE = 131;

     WM_NCCREATE = 129;

     WM_NCDESTROY = 130;

     WM_NCHITTEST = 132;

     WM_NCLBUTTONDBLCLK = 163;

     WM_NCLBUTTONDOWN = 161;

     WM_NCLBUTTONUP = 162;

     WM_NCMBUTTONDBLCLK = 169;

     WM_NCMBUTTONDOWN = 167;

     WM_NCMBUTTONUP = 168;

     WM_NCMOUSEMOVE = 160;

     WM_NCPAINT = 133;

     WM_NCRBUTTONDBLCLK = 166;

     WM_NCRBUTTONDOWN = 164;

     WM_NCRBUTTONUP = 165;

     WM_NEXTDLGCTL = 40;

     WM_NOTIFY = 78;

     WM_NOTIFYFORMAT = 85;

     WM_NULL = 0;

     WM_PAINT = 15;

     WM_PAINTCLIPBOARD = 777;

     WM_PAINTICON = 38;

     WM_PALETTECHANGED = 785;

     WM_PALETTEISCHANGING = 784;

     WM_PARENTNOTIFY = 528;

     WM_PASTE = 770;

     WM_PENWINFIRST = 896;

     WM_PENWINLAST = 911;

     WM_POWER = 72;

     WM_POWERBROADCAST = 536;

     WM_PRINT = 791;

     WM_PRINTCLIENT = 792;

     WM_PSD_ENVSTAMPRECT = 1029;

     WM_PSD_FULLPAGERECT = 1025;

     WM_PSD_GREEKTEXTRECT = 1028;

     WM_PSD_MARGINRECT = 1027;

     WM_PSD_MINMARGINRECT = 1026;

     WM_PSD_PAGESETUPDLG = 1024;

     WM_PSD_YAFULLPAGERECT = 1030;

     WM_QUERYDRAGICON = 55;

     WM_QUERYENDSESSION = 17;

     WM_QUERYNEWPALETTE = 783;

     WM_QUERYOPEN = 19;

     WM_QUEUESYNC = 35;

     WM_QUIT = 18;

     WM_RBUTTONDBLCLK = 518;

     WM_RBUTTONDOWN = 516;

     WM_RBUTTONUP = 517;

     WM_RENDERALLFORMATS = 774;

     WM_RENDERFORMAT = 773;

     WM_SETCURSOR = 32;

     WM_SETFOCUS = 7;

     WM_SETFONT = 48;

     WM_SETHOTKEY = 50;

     WM_SETICON = 128;

     WM_SETREDRAW = 11;

     WM_SETTEXT = 12;

     WM_SETTINGCHANGE = 26;

     WM_SHOWWINDOW = 24;

     WM_SIZE = 5;

     WM_SIZECLIPBOARD = 779;

     WM_SIZING = 532;

     WM_SPOOLERSTATUS = 42;

     WM_STYLECHANGED = 125;

     WM_STYLECHANGING = 124;

     WM_SYSCHAR = 262;

     WM_SYSCOLORCHANGE = 21;

     WM_SYSCOMMAND = 274;

     WM_SYSDEADCHAR = 263;

     WM_SYSKEYDOWN = 260;

     WM_SYSKEYUP = 261;

     WM_TCARD = 82;

     WM_TIMECHANGE = 30;

     WM_TIMER = 275;

     WM_UNDO = 772;

     WM_USER = 1024;

     WM_USERCHANGED = 84;

     WM_VKEYTOITEM = 46;

     WM_VSCROLL = 277;

     WM_VSCROLLCLIPBOARD = 778;

     WM_WINDOWPOSCHANGED = 71;

     WM_WINDOWPOSCHANGING = 70;

     WM_WININICHANGE = 26;

  { Window message ranges  }

     WM_KEYFIRST = 256;

     WM_KEYLAST = 264;

     WM_MOUSEFIRST = 512;

     WM_MOUSELAST = 521;



{***********************************************************************}

{   The majority of the following is as taken from the Lazarus source   }

{   which also falls under the same license as the preceeding(LGPL)     }

{***********************************************************************}

const

//------------

// KeyFlags

//------------

  KF_Extended = $100;

  KF_SHIFTDOWN = $200;

  KF_CTRLDOWN = $400;

  KF_DLGMODE = $800;

  KF_MENUMODE = $1000;

  KF_ALTDOWN = $2000;

  KF_REPEAT = $4000;

  KF_UP = $8000;



//-------------

// Virtual keys

//-------------

  VK_UNKNOWN    = 0;

  VK_LBUTTON    = 1;

  VK_RBUTTON    = 2;

  VK_CANCEL     = 3;

  VK_MBUTTON    = 4;

  VK_BACK       = 8;

  VK_TAB        = 9;

  VK_CLEAR      = 12;

  VK_RETURN     = 13;

  VK_SHIFT      = 16;

  VK_CONTROL    = 17;

  VK_MENU       = 18;

  VK_PAUSE      = 19;

  VK_CAPITAL    = 20;

  VK_KANA       = 21;

  VK_HANGUL     = 21;

  VK_JUNJA      = 23;

  VK_FINAL      = 24;

  VK_HANJA      = 25;

  VK_KANJI      = 25;

  VK_ESCAPE     = 27;

  VK_CONVERT    = 28;

  VK_NONCONVERT = 29;

  VK_ACCEPT     = 30;

  VK_MODECHANGE = 31;

  VK_SPACE      = 32;

  VK_PRIOR      = 33;

  VK_NEXT       = 34;

  VK_END        = 35;

  VK_HOME       = 36;

  VK_LEFT       = 37;

  VK_UP         = 38;

  VK_RIGHT      = 39;

  VK_DOWN       = 40;

  VK_SELECT     = 41;

  VK_PRINT      = 42;

  VK_EXECUTE    = 43;

  VK_SNAPSHOT   = 44;

  VK_INSERT     = 45;

  VK_DELETE     = 46;

  VK_HELP       = 47;

  VK_0          = $30;

  VK_1          = $31;

  VK_2          = $32;

  VK_3          = $33;

  VK_4          = $34;

  VK_5          = $35;

  VK_6          = $36;

  VK_7          = $37;

  VK_8          = $38;

  VK_9          = $39;

  VK_A	        = $41;

  VK_B	        = $42;

  VK_C	        = $43;

  VK_D	        = $44;

  VK_E	        = $45;

  VK_F	        = $46;

  VK_G	        = $47;

  VK_H	        = $48;

  VK_I	        = $49;

  VK_J	        = $4A;

  VK_K	        = $4B;

  VK_L	        = $4C;

  VK_M	        = $4D;

  VK_N	        = $4E;

  VK_O	        = $4F;

  VK_P	        = $50;

  VK_Q	        = $51;

  VK_R	        = $52;

  VK_S	        = $53;

  VK_T	        = $54;

  VK_U	        = $55;

  VK_V	        = $56;

  VK_W	        = $57;

  VK_X	        = $58;

  VK_Y	        = $59;

  VK_Z	        = $5A;

  VK_LWIN       = 91;

  VK_RWIN       = 92;

  VK_APPS       = 93;

  VK_NUMPAD0    = 96;

  VK_NUMPAD1    = 97;

  VK_NUMPAD2    = 98;

  VK_NUMPAD3    = 99;

  VK_NUMPAD4    = 100;

  VK_NUMPAD5    = 101;

  VK_NUMPAD6    = 102;

  VK_NUMPAD7    = 103;

  VK_NUMPAD8    = 104;

  VK_NUMPAD9    = 105;

  VK_MULTIPLY   = 106;

  VK_ADD        = 107;

  VK_SEPARATOR  = 108;

  VK_SUBTRACT   = 109;

  VK_DECIMAL    = 110;

  VK_DIVIDE     = 111;

  VK_F1         = 112;

  VK_F2         = 113;

  VK_F3         = 114;

  VK_F4         = 115;

  VK_F5         = 116;

  VK_F6         = 117;

  VK_F7         = 118;

  VK_F8         = 119;

  VK_F9         = 120;

  VK_F10        = 121;

  VK_F11        = 122;

  VK_F12        = 123;

  VK_F13        = 124;

  VK_F14        = 125;

  VK_F15        = 126;

  VK_F16        = 127;

  VK_F17        = 128;

  VK_F18        = 129;

  VK_F19        = 130;

  VK_F20        = 131;

  VK_F21        = 132;

  VK_F22        = 133;

  VK_F23        = 134;

  VK_F24        = 135;

  VK_NUMLOCK    = 144;

  VK_SCROLL     = 145;

  VK_LSHIFT     = 160;

  VK_RSHIFT     = 161;

  VK_LCONTROL   = 162;

  VK_RCONTROL   = 163;

  VK_LMENU      = 164;

  VK_RMENU      = 165;

  VK_PROCESSKEY = 229;

  VK_ATTN       = 246;

  VK_CRSEL      = 247;

  VK_EXSEL      = 248;

  VK_EREOF      = 249;

  VK_PLAY       = 250;

  VK_ZOOM       = 251;

  VK_NONAME     = 252;

  VK_PA1        = 253;

  VK_OEM_CLEAR  = 254;



  Type

    THandle = Handle;



    TRect = Record

      Left,

      Top,

      Right,

      Bottom : Integer;

    end;

    PRect = ^TRect;

 

    TSize = Record

      cx,

      cy : Integer;

    end;

    PSize = ^TSize;



    TPoint = Record

      x,

      y : Integer;

    end;

    PPoint = ^TPoint;





    TFarProc = FARPROC;



     LOGPEN = record

          lopnStyle : UINT;

          lopnWidth : TPOINT;

          lopnColor : TCOLORREF;

       end;

     tagLOGPEN = LOGPEN;

     TLOGPEN = LOGPEN;

     PLOGPEN = ^LOGPEN;



   const

     PS_SOLID = 0;

     PS_DASH = 1;

     PS_DOT = 2;

     PS_DASHDOT = 3;

     PS_DASHDOTDOT = 4;

     PS_NULL = 5;

     PS_INSIDEFRAME = 6;

     PS_USERSTYLE = 7;



  Type

     LOGBRUSH = record

          lbStyle : UINT;

          lbColor : COLORREF;

          lbHatch : LONG;

       end;

     tagLOGBRUSH = LOGBRUSH;

     TLOGBRUSH = LOGBRUSH;

     PLOGBRUSH = ^LOGBRUSH;



  Const

     BS_SOLID = 0;

     BS_NULL = 1; 

     BS_HOLLOW = BS_NULL;

     BS_HATCHED = 2;

     BS_PATTERN = 3;

     HS_HORIZONTAL = 0;

     HS_VERTICAL   = 1;

     HS_FDIAGONAL  = 2;

     HS_BDIAGONAL  = 3;

     HS_CROSS      = 4;

     HS_DIAGCROSS  = 5;



  const

     LF_FACESIZE = 32;

     LF_FULLFACESIZE = 64;



  Type

     LOGFONT = record

          lfHeight : LONG;

          lfWidth : LONG;

          lfEscapement : LONG;

          lfOrientation : LONG;

          lfWeight : LONG;

          lfItalic : BYTE;

          lfUnderline : BYTE;

          lfStrikeOut : BYTE;

          lfCharSet : BYTE;

          lfOutPrecision : BYTE;

          lfClipPrecision : BYTE;

          lfQuality : BYTE;

          lfPitchAndFamily : BYTE;

          lfFaceName : array[0..(LF_FACESIZE)-1] of TCHAR;

       end;

     LPLOGFONT = ^LOGFONT;

     TLOGFONT = LOGFONT;

     TLOGFONTA = LOGFONT;

     PLOGFONT = ^LOGFONT;



  const{These consts were taken from WOL's wolPen.pp}

    FW_DONTCARE   =   0;

    FW_THIN       = 100;

    FW_EXTRALIGHT = 200;

    FW_ULTRALIGHT = 250;

    FW_LIGHT      = 300;

    FW_NORMAL     = 400;

    FW_REGULAR    = 450;

    FW_MEDIUM     = 500;

    FW_SEMIBOLD   = 600;

    FW_DEMIBOLD   = 650;

    FW_BOLD       = 700;

    FW_EXTRABOLD  = 800;

    FW_ULTRABOLD  = 850;

    FW_HEAVY      = 900;

    FW_BLACK      = 950;



  WHITE_BRUSH = 0;

  LTGRAY_BRUSH = 1;

  GRAY_BRUSH = 2;

  DKGRAY_BRUSH = 3;

  BLACK_BRUSH = 4;

  NULL_BRUSH = 5;

  HOLLOW_BRUSH = NULL_BRUSH;

  WHITE_PEN = 6;

  BLACK_PEN = 7;

  NULL_PEN = 8;

  OEM_FIXED_FONT = 10;

  ANSI_FIXED_FONT = 11;

  ANSI_VAR_FONT = 12;

  SYSTEM_FONT = 13;

  DEVICE_DEFAULT_FONT = 14;

  DEFAULT_PALETTE = 15;

  SYSTEM_FIXED_FONT = $10;

  DEFAULT_GUI_FONT = 17;

  DC_BRUSH = 18;

  DC_PEN = 19;

  STOCK_LAST = 19;



  COLOR_SCROLLBAR = 0;

  COLOR_BACKGROUND = 1;

  COLOR_ACTIVECAPTION = 2;

  COLOR_INACTIVECAPTION = 3;

  COLOR_MENU = 4;

  COLOR_WINDOW = 5;

  COLOR_WINDOWFRAME = 6;

  COLOR_MENUTEXT = 7;

  COLOR_WINDOWTEXT = 8;

  COLOR_CAPTIONTEXT = 9;

  COLOR_ACTIVEBORDER = 10;

  COLOR_INACTIVEBORDER = 11;

  COLOR_APPWORKSPACE = 12;

  COLOR_HIGHLIGHT = 13;

  COLOR_HIGHLIGHTTEXT = 14;

  COLOR_BTNFACE = 15;

  COLOR_BTNSHADOW = $10;

  COLOR_GRAYTEXT = 17;

  COLOR_BTNTEXT = 18;

  COLOR_INACTIVECAPTIONTEXT = 19;

  COLOR_BTNHIGHLIGHT = 20;

  COLOR_3DDKSHADOW = 21;

  COLOR_3DLIGHT = 22;

  COLOR_INFOTEXT = 23;

  COLOR_INFOBK = 24;

  COLOR_HOTLIGHT = 26;

  COLOR_GRADIENTACTIVECAPTION = 27;

  COLOR_GRADIENTINACTIVECAPTION = 28;

  COLOR_ENDCOLORS = COLOR_GRADIENTINACTIVECAPTION;

  COLOR_DESKTOP = COLOR_BACKGROUND;

  COLOR_3DFACE = COLOR_BTNFACE;

  COLOR_3DSHADOW = COLOR_BTNSHADOW;

  COLOR_3DHIGHLIGHT = COLOR_BTNHIGHLIGHT;

  COLOR_3DHILIGHT = COLOR_BTNHIGHLIGHT;

  COLOR_BTNHILIGHT = COLOR_BTNHIGHLIGHT;



  const

    TRANSPARENT = 1;

    OPAQUE = 2;

    BKMODE_LAST = 2;



  Type

    PBitmap = ^Bitmap;

    BITMAP = packed record

      bmType: Longint;

      bmWidth: Longint;

      bmHeight: Longint;

      bmWidthBytes: Longint;

      bmPlanes: Word;

      bmBitsPixel: Word;

      bmBits: Pointer;

    end;

    TagBitmap = BITMAP;

    TBITMAP = BITMAP;

  

  Type

    WNDPROC = function (_para1:HWND; _para2:UINT; _para3:WPARAM; _para4:LPARAM):LRESULT;stdcall;



    TWNDPROC = WNDPROC;



    TFNWndProc = TFarProc;



    WNDCLASS = record

      style : UINT;

      lpfnWndProc : WNDPROC;

      cbClsExtra : longint;

      cbWndExtra : longint;

      hInstance : HANDLE;

      hIcon : HICON;

      hCursor : HCURSOR;

      hbrBackground : HBRUSH;

      lpszMenuName : LPCTSTR;

      lpszClassName : LPCTSTR;

     end;

     LPWNDCLASS = ^WNDCLASS;

     _WNDCLASS = WNDCLASS;

     TWNDCLASS = WNDCLASS;

     TWNDCLASSA = WNDCLASS;

     PWNDCLASS = ^WNDCLASS;



     WNDCLASSEX = record

          cbSize : UINT;

          style : UINT;

          lpfnWndProc : WNDPROC;

          cbClsExtra : longint;

          cbWndExtra : longint;

          hInstance : HANDLE;

          hIcon : 	HICON;

          hCursor : HCURSOR;

          hbrBackground : HBRUSH;

          lpszMenuName : LPCTSTR;

          lpszClassName : LPCTSTR;

          hIconSm : HANDLE;

       end;

     LPWNDCLASSEX = ^WNDCLASSEX;

     _WNDCLASSEX = WNDCLASSEX;

     TWNDCLASSEX = WNDCLASSEX;

     TWNDCLASSEXA = WNDCLASSEX;

     PWNDCLASSEX = ^WNDCLASSEX;



  const

    WS_OVERLAPPED = 0;

    WS_POPUP = DWORD($80000000);

    WS_CHILD = $40000000;

    WS_MINIMIZE = $20000000;

    WS_VISIBLE = $10000000;

    WS_DISABLED = $8000000;

    WS_CLIPSIBLINGS = $4000000;

    WS_CLIPCHILDREN = $2000000;

    WS_MAXIMIZE = $1000000;

    WS_CAPTION = $C00000;

    WS_BORDER = $800000;

    WS_DLGFRAME = $400000;

    WS_VSCROLL = $200000;

    WS_HSCROLL = $100000;

    WS_SYSMENU = $80000;

    WS_THICKFRAME = $40000;

    WS_GROUP = $20000;

    WS_TABSTOP = $10000;

    WS_MINIMIZEBOX = $20000;

    WS_MAXIMIZEBOX = $10000;

    WS_TILED = WS_OVERLAPPED;

    WS_ICONIC = WS_MINIMIZE;

    WS_SIZEBOX = WS_THICKFRAME;

    WS_OVERLAPPEDWINDOW = (WS_OVERLAPPED or WS_CAPTION or WS_SYSMENU or

      WS_THICKFRAME or WS_MINIMIZEBOX or WS_MAXIMIZEBOX);

    WS_TILEDWINDOW = WS_OVERLAPPEDWINDOW;

    WS_POPUPWINDOW = (WS_POPUP or WS_BORDER or WS_SYSMENU);

    WS_CHILDWINDOW = (WS_CHILD);

    WS_EX_DLGMODALFRAME = 1;

    WS_EX_NOPARENTNOTIFY = 4;

    WS_EX_TOPMOST = 8;

    WS_EX_ACCEPTFILES = $10;

    WS_EX_TRANSPARENT = $20;

    WS_EX_MDICHILD = $40;

    WS_EX_TOOLWINDOW = $80;

    WS_EX_WINDOWEDGE = $100;

    WS_EX_CLIENTEDGE = $200;

    WS_EX_CONTEXTHELP = $400;

    WS_EX_RIGHT = $1000;

    WS_EX_LEFT = 0;

    WS_EX_RTLREADING = $2000;

    WS_EX_LTRREADING = 0;

    WS_EX_LEFTSCROLLBAR = $4000;

    WS_EX_RIGHTSCROLLBAR = 0;

    WS_EX_CONTROLPARENT = $10000;

    WS_EX_STATICEDGE = $20000;

    WS_EX_APPWINDOW = $40000;

    WS_EX_OVERLAPPEDWINDOW = (WS_EX_WINDOWEDGE or WS_EX_CLIENTEDGE);

    WS_EX_PALETTEWINDOW = (WS_EX_WINDOWEDGE or WS_EX_TOOLWINDOW or WS_EX_TOPMOST);

    CS_VREDRAW = DWORD(1);

    CS_HREDRAW = DWORD(2);

    CS_KEYCVTWINDOW = 4;

    CS_DBLCLKS = 8;

    CS_OWNDC = $20;

    CS_CLASSDC = $40;

    CS_PARENTDC = $80;

    CS_NOKEYCVT = $100;

    CS_NOCLOSE = $200;

    CS_SAVEBITS = $800;

    CS_BYTEALIGNCLIENT = $1000;

    CS_BYTEALIGNWINDOW = $2000;

    CS_GLOBALCLASS = $4000;

    CS_IME = $10000;



    BS_PUSHBUTTON = 0;

    BS_DEFPUSHBUTTON = 1;

    BS_CHECKBOX = 2;

    BS_AUTOCHECKBOX = 3;

    BS_RADIOBUTTON = 4;

    BS_3STATE = 5;

    BS_AUTO3STATE = 6;

    BS_GROUPBOX = 7;

    BS_USERBUTTON = 8;

    BS_AUTORADIOBUTTON = 9;

    BS_OWNERDRAW = 11;

    BS_LEFTTEXT = $20;

    BS_TEXT = 0;

    BS_ICON = $40;

    BS_BITMAP = $80;

    BS_LEFT = $100;

    BS_RIGHT = $200;

    BS_CENTER = 768;

    BS_TOP = $400;

    BS_BOTTOM = $800;

    BS_VCENTER = 3072;

    BS_PUSHLIKE = $1000;

    BS_MULTILINE = $2000;

    BS_NOTIFY = $4000;

    BS_FLAT = $8000;

    BS_RIGHTBUTTON = BS_LEFTTEXT;

    BST_UNCHECKED = 0;

    BST_CHECKED = 1;

    BST_INDETERMINATE = 2;

    BST_PUSHED = 4;

    BST_FOCUS = 8;

    ES_LEFT = 0;

    ES_CENTER = 1;

    ES_RIGHT = 2;

    ES_MULTILINE = 4;

    ES_UPPERCASE = 8;

    ES_LOWERCASE = $10;

    ES_PASSWORD = $20;

    ES_AUTOVSCROLL = $40;

    ES_AUTOHSCROLL = $80;

    ES_NOHIDESEL = $100;

    ES_OEMCONVERT = $400;

    ES_READONLY = $800;

    ES_WANTRETURN = $1000;

    ES_NUMBER = $2000;

    EC_LEFTMARGIN = 1;

    EC_RIGHTMARGIN = 2;

    EC_USEFONTINFO = 65535;



    SS_LEFT = 0;

    SS_CENTER = 1;

    SS_RIGHT = 2;

    SS_ICON = 3;

    SS_BLACKRECT = 4;

    SS_GRAYRECT = 5;

    SS_WHITERECT = 6;

    SS_BLACKFRAME = 7;

    SS_GRAYFRAME = 8;

    SS_WHITEFRAME = 9;

    SS_USERITEM = 10;

    SS_SIMPLE = 11;

    SS_LEFTNOWORDWRAP = 12;

    SS_BITMAP = 14;

    SS_OWNERDRAW = 13;

    SS_ENHMETAFILE = 15;

    SS_ETCHEDHORZ = $10;

    SS_ETCHEDVERT = 17;

    SS_ETCHEDFRAME = 18;

    SS_TYPEMASK = 31;

    SS_NOPREFIX = $80;

    SS_NOTIFY = $100;

    SS_CENTERIMAGE = $200;

    SS_RIGHTJUST = $400;

    SS_REALSIZEIMAGE = $800;

    SS_SUNKEN = $1000;

    SS_ENDELLIPSIS =  $4000;

    SS_PATHELLIPSIS = $8000;

    SS_WORDELLIPSIS = $C000;

    SS_ELLIPSISMASK = $C000;



    CBS_SIMPLE = 1;

    CBS_DROPDOWN = 2;

    CBS_DROPDOWNLIST = 3;

    CBS_OWNERDRAWFIXED = $10;

    CBS_OWNERDRAWVARIABLE = $20;

    CBS_AUTOHSCROLL = $40;

    CBS_OEMCONVERT = $80;

    CBS_SORT = $100;

    CBS_HASSTRINGS = $200;

    CBS_NOINTEGRALHEIGHT = $400;

    CBS_DISABLENOSCROLL = $800;

    CBS_UPPERCASE = $2000;

    CBS_LOWERCASE = $4000;



    SBS_HORZ = 0;

    SBS_VERT = 1;

    SBS_TOPALIGN = 2;

    SBS_LEFTALIGN = 2;

    SBS_BOTTOMALIGN = 4;

    SBS_RIGHTALIGN = 4;

    SBS_SIZEBOXTOPLEFTALIGN = 2;

    SBS_SIZEBOXBOTTOMRIGHTALIGN = 4;

    SBS_SIZEBOX = 8;

    SBS_SIZEGRIP = $10;



    LBS_NOTIFY = 1;

    LBS_SORT = 2;

    LBS_NOREDRAW = 4;

    LBS_MULTIPLESEL = 8;

    LBS_OWNERDRAWFIXED = $10;

    LBS_OWNERDRAWVARIABLE = $20;

    LBS_HASSTRINGS = $40;

    LBS_USETABSTOPS = $80;

    LBS_NOINTEGRALHEIGHT = $100;

    LBS_MULTICOLUMN = $200;

    LBS_WANTKEYBOARDINPUT = $400;

    LBS_EXTENDEDSEL = $800;

    LBS_DISABLENOSCROLL = $1000;

    LBS_NODATA = $2000;

    LBS_NOSEL = $4000;

    LBS_STANDARD = (LBS_NOTIFY or LBS_SORT or WS_VSCROLL or WS_BORDER);



    MDIS_ALLCHILDSTYLES = 1;

    MDITILE_VERTICAL = 0;

    MDITILE_HORIZONTAL = 1;

    MDITILE_SKIPDISABLED = 2;



    SW_HIDE = 0;

    SW_SHOWNORMAL = 1;

    SW_NORMAL = 1;

    SW_SHOWMINIMIZED = 2;

    SW_SHOWMAXIMIZED = 3;

    SW_MAXIMIZE = 3;

    SW_SHOWNOACTIVATE = 4;

    SW_SHOW = 5;

    SW_MINIMIZE = 6;

    SW_SHOWMINNOACTIVE = 7;

    SW_SHOWNA = 8;

    SW_RESTORE = 9;

    SW_SHOWDEFAULT = 10;

    SW_MAX = 10;



    HIDE_WINDOW = 0;

    SHOW_OPENWINDOW = 1;

    SHOW_ICONWINDOW = 2;

    SHOW_FULLSCREEN = 3;

    SHOW_OPENNOACTIVATE = 4;



  Type

    PMsg = ^TMsg;

    tagMSG = packed record

      hwnd: HWND;

      message: UINT;

      wParam: WPARAM;

      lParam: LPARAM;

      time: DWORD;

      pt: TPoint;

    end;

    TMsg = tagMSG;

    MSG = tagMSG;



  type

    PWindowPos = ^TWindowPos;

    tagWINDOWPOS = packed record

      hwnd: CPWindows.HWND;

      hwndInsertAfter: CPWindows.HWND;

      x: Integer;

      y: Integer;

      cx: Integer;

      cy: Integer;

      flags: UINT;

    end;

    TWindowPos = tagWINDOWPOS;

    WINDOWPOS = tagWINDOWPOS;



  Type

    MakeIntResourceA = PAnsiChar;

    MakeIntResourceW = PWideChar;

    MakeIntResource = MakeIntResourceA;



  const

    IDC_ARROW = MakeIntResource(32512);

    IDC_IBEAM = MakeIntResource(32513);

    IDC_WAIT = MakeIntResource(32514);

    IDC_CROSS = MakeIntResource(32515);

    IDC_UPARROW = MakeIntResource(32516);

    IDC_SIZE = MakeIntResource(32640);

    IDC_ICON = MakeIntResource(32641);

    IDC_SIZENWSE = MakeIntResource(32642);

    IDC_SIZENESW = MakeIntResource(32643);

    IDC_SIZEWE = MakeIntResource(32644);

    IDC_SIZENS = MakeIntResource(32645);

    IDC_SIZEALL = MakeIntResource(32646);

    IDC_NO = MakeIntResource(32648);

    IDC_HAND = MakeIntResource(32649);

    IDC_APPSTARTING = MakeIntResource(32650);

    IDC_HELP = MakeIntResource(32651);



  type

    POSVersionInfoA = ^TOSVersionInfoA;

    POSVersionInfoW = ^TOSVersionInfoW;

    POSVersionInfo = POSVersionInfoA;

    _OSVERSIONINFOA = record

      dwOSVersionInfoSize: DWORD;

      dwMajorVersion: DWORD;

      dwMinorVersion: DWORD;

      dwBuildNumber: DWORD;

      dwPlatformId: DWORD;

      szCSDVersion: array[0..127] of AnsiChar;

    end;

    _OSVERSIONINFOW = record

      dwOSVersionInfoSize: DWORD;

      dwMajorVersion: DWORD;

      dwMinorVersion: DWORD;

      dwBuildNumber: DWORD;

      dwPlatformId: DWORD;

      szCSDVersion: array[0..127] of WideChar;

    end;

    _OSVERSIONINFO = _OSVERSIONINFOA;

    TOSVersionInfoA = _OSVERSIONINFOA;

    TOSVersionInfoW = _OSVERSIONINFOW;

    TOSVersionInfo = TOSVersionInfoA;

    OSVERSIONINFOA = _OSVERSIONINFOA;

    OSVERSIONINFOW = _OSVERSIONINFOW;

    OSVERSIONINFO = OSVERSIONINFOA;



  const

    VER_PLATFORM_WIN32s = 0;

    VER_PLATFORM_WIN32_WINDOWS = 1;

    VER_PLATFORM_WIN32_NT = 2;



  type

    PLIST_ENTRY = ^LIST_ENTRY;

    LIST_ENTRY = record

      Flink : PLIST_ENTRY;

      Blink : PLIST_ENTRY;

    end;

    TLISTENTRY = LIST_ENTRY;



    PCRITICAL_SECTION = ^CRITICAL_SECTION;

    CRITICAL_SECTION_DEBUG = record

      _Type : WORD;

      CreatorBackTraceIndex : WORD;

      CriticalSection : PCRITICAL_SECTION;

      ProcessLocksList : LIST_ENTRY;

      EntryCount : DWORD;

      ContentionCount : DWORD;

      Depth : DWORD;

      OwnerBackTrace : array[0..4] of PVOID;

    end;

    LPCRITICAL_SECTION_DEBUG = ^CRITICAL_SECTION_DEBUG;

    PCRITICAL_SECTION_DEBUG = CRITICAL_SECTION_DEBUG;

    _CRITICAL_SECTION_DEBUG = CRITICAL_SECTION_DEBUG;

    TCRITICALSECTIONDEBUG = CRITICAL_SECTION_DEBUG;

    PCRITICALSECTIONDEBUG = ^CRITICAL_SECTION_DEBUG;



    CRITICAL_SECTION = record

      DebugInfo : PCRITICAL_SECTION_DEBUG;

      LockCount : LONG;

      RecursionCount : LONG;

      OwningThread : HANDLE;

      LockSemaphore : HANDLE;

      Reserved : DWORD;

    end;

    LPCRITICAL_SECTION = ^CRITICAL_SECTION;

    _CRITICAL_SECTION = CRITICAL_SECTION;

    TCRITICALSECTION = CRITICAL_SECTION;

    PCRITICALSECTION = ^CRITICAL_SECTION;



    TRTLCriticalSection = CRITICAL_SECTION;

    PRTLCriticalSection = PCRITICAL_SECTION;



  const

    RTL_CRITSECT_TYPE = 0;

    RTL_RESOURCE_TYPE = 1;



  const

    R2_BLACK       = 1;

    R2_NOTMERGEPEN = 2;

    R2_MASKNOTPEN  = 3;

    R2_NOTCOPYPEN  = 4;

    R2_MASKPENNOT  = 5;

    R2_NOT         = 6;

    R2_XORPEN      = 7;

    R2_NOTMASKPEN  = 8;

    R2_MASKPEN     = 9;

    R2_NOTXORPEN   = 10;

    R2_NOP         = 11;

    R2_MERGENOTPEN = 12;

    R2_COPYPEN     = 13;

    R2_MERGEPENNOT = 14;

    R2_MERGEPEN    = 15;

    R2_WHITE       = $10;

    R2_LAST        = $10;



  const

    DT_TOP = 0;

    DT_LEFT = 0;

    DT_CENTER = 1;

    DT_RIGHT = 2;

    DT_VCENTER = 4;

    DT_BOTTOM = 8;

    DT_WORDBREAK = $10;

    DT_SINGLELINE = $20;

    DT_EXPANDTABS = $40;

    DT_TABSTOP = $80;

    DT_NOCLIP = $100;

    DT_EXTERNALLEADING = $200;

    DT_CALCRECT = $400;

    DT_NOPREFIX = $800;

    DT_INTERNAL = $1000;

    DT_EDITCONTROL = $2000;

    DT_PATH_ELLIPSIS = $4000;

    DT_END_ELLIPSIS = $8000;

    DT_MODIFYSTRING = $10000;

    DT_RTLREADING = $20000;

    DT_WORD_ELLIPSIS = $40000;



  const

    FLOODFILLBORDER = 0;

    FLOODFILLSURFACE = 1;



  const

    OUT_DEFAULT_PRECIS = 0;

    OUT_STRING_PRECIS = 1;

    OUT_CHARACTER_PRECIS = 2;

    OUT_STROKE_PRECIS = 3;

    OUT_TT_PRECIS = 4;

    OUT_DEVICE_PRECIS = 5;

    OUT_RASTER_PRECIS = 6;

    OUT_TT_ONLY_PRECIS = 7;

    OUT_OUTLINE_PRECIS = 8;

    OUT_SCREEN_OUTLINE_PRECIS = 9;



    CLIP_DEFAULT_PRECIS = 0;

    CLIP_CHARACTER_PRECIS = 1;

    CLIP_STROKE_PRECIS = 2;

    CLIP_MASK = 15;

    CLIP_LH_ANGLES = (1 shl 4);

    CLIP_TT_ALWAYS = (2 shl 4);

    CLIP_EMBEDDED  = (8 shl 4);



    DEFAULT_QUALITY = 0;

    DRAFT_QUALITY = 1;

    PROOF_QUALITY = 2;

    NONANTIALIASED_QUALITY = 3;

    ANTIALIASED_QUALITY = 4;



    DEFAULT_PITCH = 0;

    FIXED_PITCH = 1;

    VARIABLE_PITCH = 2;

    MONO_FONT = 8;



    HORZSIZE      = 4;

    VERTSIZE      = 6;

    HORZRES       = 8;

    VERTRES       = 10;

    BITSPIXEL     = 12;

    NUMBRUSHES    = $10;

    NUMPENS       = 18;

    NUMFONTS      = 22;

    NUMCOLORS     = 24;

    LOGPIXELSX    = 88;

    LOGPIXELSY    = 90;

    COLORRES      = 108;

    PHYSICALWIDTH   = 110;

    PHYSICALHEIGHT  = 111;

    PHYSICALOFFSETX = 112;

    PHYSICALOFFSETY = 113;



  const

    SM_CXSCREEN = 0;

    SM_CYSCREEN = 1;

    SM_CXVSCROLL = 2;

    SM_CYHSCROLL = 3;

    SM_CYCAPTION = 4;

    SM_CXBORDER = 5;

    SM_CYBORDER = 6;

    SM_CXDLGFRAME = 7;

    SM_CYDLGFRAME = 8;

    SM_CYVTHUMB = 9;

    SM_CXHTHUMB = 10;

    SM_CXICON = 11;

    SM_CYICON = 12;

    SM_CXCURSOR = 13;

    SM_CYCURSOR = 14;

    SM_CYMENU = 15;

    SM_CXFULLSCREEN = $10;

    SM_CYFULLSCREEN = 17;

    SM_CYKANJIWINDOW = 18;

    SM_MOUSEPRESENT = 19;

    SM_CYVSCROLL = 20;

    SM_CXHSCROLL = 21;

    SM_DEBUG = 22;

    SM_SWAPBUTTON = 23;

    SM_RESERVED1 = 24;

    SM_RESERVED2 = 25;

    SM_RESERVED3 = 26;

    SM_RESERVED4 = 27;

    SM_CXMIN = 28;

    SM_CYMIN = 29;

    SM_CXSIZE = 30;

    SM_CYSIZE = 31;

    SM_CXFRAME = $20;

    SM_CYFRAME = 33;

    SM_CXMINTRACK = 34;

    SM_CYMINTRACK = 35;

    SM_CXDOUBLECLK = 36;

    SM_CYDOUBLECLK = 37;

    SM_CXICONSPACING = 38;

    SM_CYICONSPACING = 39;

    SM_MENUDROPALIGNMENT = 40;

    SM_PENWINDOWS = 41;

    SM_DBCSENABLED = 42;

    SM_CMOUSEBUTTONS = 43;

    SM_CXFIXEDFRAME = SM_CXDLGFRAME;

    SM_CYFIXEDFRAME = SM_CYDLGFRAME;

    SM_CXSIZEFRAME = SM_CXFRAME;

    SM_CYSIZEFRAME = SM_CYFRAME;

    SM_SECURE = 44;

    SM_CXEDGE = 45;

    SM_CYEDGE = 46;

    SM_CXMINSPACING = 47;

    SM_CYMINSPACING = 48;

    SM_CXSMICON = 49;

    SM_CYSMICON = 50;

    SM_CYSMCAPTION = 51;

    SM_CXSMSIZE = 52;

    SM_CYSMSIZE = 53;

    SM_CXMENUSIZE = 54;

    SM_CYMENUSIZE = 55;

    SM_ARRANGE = 56;

    SM_CXMINIMIZED = 57;

    SM_CYMINIMIZED = 58;

    SM_CXMAXTRACK = 59;

    SM_CYMAXTRACK = 60;

    SM_CXMAXIMIZED = 61;

    SM_CYMAXIMIZED = 62;

    SM_NETWORK = 63;

    SM_CLEANBOOT = 67;

    SM_CXDRAG = 68;

    SM_CYDRAG = 69;

    SM_SHOWSOUNDS = 70;

    SM_CXMENUCHECK = 71;

    SM_CYMENUCHECK = 72;

    SM_SLOWMACHINE = 73;

    SM_MIDEASTENABLED = 74;

    SM_MOUSEWHEELPRESENT = 75;

    SM_CMETRICS = 76;



  const

    GWL_WNDPROC = -4;

    GWL_HINSTANCE = -6;

    GWL_HWNDPARENT = -8;

    GWL_STYLE = -16;

    GWL_EXSTYLE = -20;

    GWL_USERDATA = -21;

    GWL_ID = -12;



  Type

    PPaintStruct = ^TPaintStruct;

    tagPAINTSTRUCT = packed record

      hdc: HDC;

      fErase: BOOL;

      rcPaint: TRect;

      fRestore: BOOL;

      fIncUpdate: BOOL;

      rgbReserved: array[0..31] of Byte;

    end;

    TPaintStruct = tagPAINTSTRUCT;

    PAINTSTRUCT = tagPAINTSTRUCT;

    lPPaintStruct = PPaintStruct;



  const

    MB_OK = $00000000;

    MB_OKCANCEL = $00000001;

    MB_ABORTRETRYIGNORE = $00000002;

    MB_YESNOCANCEL = $00000003;

    MB_YESNO = $00000004;

    MB_RETRYCANCEL = $00000005;

    MB_ICONHAND = $00000010;

    MB_ICONQUESTION = $00000020;

    MB_ICONEXCLAMATION = $00000030;

    MB_ICONASTERISK = $00000040;

    MB_USERICON = $00000080;

    MB_ICONWARNING                 = MB_ICONEXCLAMATION;

    MB_ICONERROR                   = MB_ICONHAND;

    MB_ICONINFORMATION             = MB_ICONASTERISK;

    MB_ICONSTOP                    = MB_ICONHAND;

    MB_DEFBUTTON1 = $00000000;

    MB_DEFBUTTON2 = $00000100;

    MB_DEFBUTTON3 = $00000200;

    MB_DEFBUTTON4 = $00000300;

    MB_APPLMODAL = $00000000;

    MB_SYSTEMMODAL = $00001000;

    MB_TASKMODAL = $00002000;

    MB_HELP = $00004000;

    MB_NOFOCUS = $00008000;

    MB_SETFOREGROUND = $00010000;

    MB_DEFAULT_DESKTOP_ONLY = $00020000;



    MB_TOPMOST = $00040000;

    MB_RIGHT = $00080000;

    MB_RTLREADING = $00100000;



    MB_SERVICE_NOTIFICATION = $00200000;

    MB_SERVICE_NOTIFICATION_NT3X = $00040000;



    MB_TYPEMASK = $0000000F;

    MB_ICONMASK = $000000F0;

    MB_DEFMASK = $00000F00;

    MB_MODEMASK = $00003000;

    MB_MISCMASK = $0000C000;



{***********************************************************************}

{                            FILE HISTORY                               }

{***********************************************************************}

{Version .1 (Andrew Johnson, 6/2/2001)                                  }

{                                                                       }

{  1.) Initialial import from Base.Inc                                  }

{***********************************************************************}

{Version .2 (Andrew Johnson, 6/13/2001)                                 }

{                                                                       }

{  1.) Added Virtual/Key Flags                                          }

{  2.) Modified Key flags, to make key routines easier.                 }

{***********************************************************************}

{Version .3 (Andrew Johnson, 7/11/2001)                                 }

{                                                                       }

{  1.) Added THandle,TRect,TSize,PRect,PSize                            }

{***********************************************************************}

{Version .4 (Andrew Johnson, 7/17/2001)                                 }

{                                                                       }

{  1.) Added Window messages                                            }

{***********************************************************************}

{Version .5 (Andrew Johnson, 7/18/2001)                                 }

{                                                                       }

{  1.) Added LogFont/LogPen/LogBush                                     }

{  2.) Added Brush Style/Hatch conts                                    }

{  3.) Added Pen Style consts                                           }

{  4.) Added Font Weight consts                                         }

{  5.) Added a bunch of stock object consts                             }

{  6.) Added a bunch of syscolor consts                                 }

{  7.) Added a bunch of wnd types                                       }

{***********************************************************************}

{Version .6 (Andrew Johnson, 8/15-27/2001)                              }

{                                                                       }

{***********************************************************************}