Unit GTKCallbacks;



{$Mode ObjFPC}



interface



uses CPWindows, GDK;



Type

  PCallBackHandler = ^TCallBackHandler;

  TCallBackHandler = Procedure (Msg : Longint; Vars : Array Of Const;

    Result : Pointer); cdecl;



    PMessage = ^TMessage;

    TMessage = record

                 Msg   : Word;

                 case Integer of

                      0: ( WParam  : WPARAM;

                           LParam  : LPARAM;

                           Result  : Longint );

                      1: ( WParamLo: Word;

                           WParamHi: Word;

                           LParamLo: Word;

                           LParamHi: Word;

                           ResultLo: Word;

                           ResultHi: Word );

               end;



    TWMWindowPosChanged = record

      Msg: Cardinal;

      Unused: Integer;

      WindowPos: PWindowPos;

      Result: Longint;

    end;



    TWMPaint = record

      Msg: Cardinal;

      DC: HDC;

      Unused: Longint;

      Result: Longint;

    end;



   TWMKey = record

      Msg: Cardinal;

      CharCode: Word;

      Unused: Word;

      KeyData: Longint;

      Result: Longint;

    end;



Procedure OnDestroy(Widget : Pointer; Data : Pointer); cdecl;

//Function OnFormDeleteEvent(Widget : Pointer; Data : Pointer) : integer; cdecl;

Procedure OnClicked(Widget : Pointer; Data : Pointer); cdecl;

{Procedure OnPressed(Widget : Pointer; Data : Pointer); cdecl;

Procedure OnResize(Widget : Pointer; Blah, Data : Pointer); cdecl;

Procedure OnReleased(Widget : Pointer; Data : Pointer); cdecl;

Procedure OnEnter(Widget : Pointer; Data : Pointer); cdecl;

Procedure OnLeave(Widget : Pointer; Data : Pointer); cdecl;

Procedure OnChanged(Widget : Pointer; Data : Pointer); cdecl;

Function OnButtonPress(Widget : Pointer;  ButtonData : PGDKEventButton; Data : Pointer) : Boolean; cdecl;

}

Function OnKeyUpDown(Widget: Pointer; Event : PGDKEventKey; Data: Pointer) : Boolean; cdecl;

{Function OnMouseMove(Widget : Pointer; Event : Pointer; Data : Pointer) : Boolean; cdecl;

Function OnFocusEnter(Widget : Pointer; Event : Pointer; Data : Pointer) : Boolean; cdecl;

Function OnFocusExit(Widget : Pointer; Event : Pointer; Data : Pointer) : Boolean; cdecl;}



var

  CBH : TCallBackHandler;



implementation



{This routine was taken from the Lazarus LCL, and then further modified by myself}

procedure GetGTKKeyInfo(const Event: PGDKEventKey; var KeyCode, VirtualKey: Word; var SysKey, Extended, Toggle: Boolean);

var

  CtrlDown: Boolean;

begin

  VirtualKey := VK_UNKNOWN;

  KeyCode := $FFFF;

  SysKey := (Event^.State and GDK_MOD1_MASK) <> 0;

  CtrlDown := (Event^.State and GDK_CONTROL_MASK) <> 0;

  Extended := False;

  Toggle := False;

  case Event^.KeyVal of

    32..255 : 

      begin

        KeyCode := Event^.KeyVal;

	case Chr(KeyCode) of

	  ')': VirtualKey := ord('0');

	  '!': VirtualKey := ord('1');

	  '@': VirtualKey := ord('2');

	  '#': VirtualKey := ord('3');

	  '$': VirtualKey := ord('4');

	  '%': VirtualKey := ord('5');

	  '^': VirtualKey := ord('6');

	  '&': VirtualKey := ord('7');

	  '*': VirtualKey := ord('8');

	  '(': VirtualKey := ord('9');

          'a'..'z': VirtualKey := KeyCode - 32;

          'A'..'Z', 

          '0'..'9', 

          ' ': VirtualKey := KeyCode;

        end;

        

        if CtrlDown and (Chr(KeyCode) in ['@'..'Z'])

        then Dec(KeyCode, Ord('@'));

      end;

      

    GDK_KP_Space:

      begin

        KeyCode := VK_SPACE;

        VirtualKey := VK_SPACE;

      end;

    GDK_KP_Tab:

      begin

        KeyCode := VK_TAB;

        VirtualKey := VK_TAB;

      end;

    GDK_KP_Enter:

      begin

        KeyCode := VK_Return;

        VirtualKey := VK_Return;

      end;

    GDK_Tab:

      begin

        KeyCode := VK_TAB;

        VirtualKey := VK_TAB;

      end;

    GDK_Return:

      begin

        KeyCode := VK_RETURN;

        VirtualKey := VK_RETURN;

      end;

    GDK_Linefeed: 

      begin

        KeyCode := $0A;

        VirtualKey := $0A;

      end;

 

    GDK_Insert:         

      begin

        VirtualKey := VK_INSERT;

        Extended := True;

      end;

    GDK_Home:           

      begin

        VirtualKey := VK_HOME;

        Extended := True;

      end;

    GDK_Left:           

      begin

        VirtualKey := VK_LEFT;

        Extended := True;

      end;

    GDK_Up:             

      begin

        VirtualKey := VK_UP;

        Extended := True;

      end;

    GDK_Right:          

      begin

        VirtualKey := VK_RIGHT;

        Extended := True;

      end;

    GDK_Down:           

      begin

        VirtualKey := VK_DOWN;

        Extended := True;

      end;

    GDK_Page_Up:        

      begin

        VirtualKey := VK_PRIOR;

        Extended := True;

      end;

    GDK_Page_Down:      

      begin

        VirtualKey := VK_NEXT;

        Extended := True;

      end;

    GDK_End:            

      begin

        VirtualKey := VK_END;

        Extended := True;

      end;

    

    GDK_KP_Insert:      VirtualKey := VK_INSERT;

    GDK_KP_Home:        VirtualKey := VK_HOME;

    GDK_KP_Left:        VirtualKey := VK_LEFT;

    GDK_KP_Up:          VirtualKey := VK_UP;

    GDK_KP_Right:       VirtualKey := VK_RIGHT;

    GDK_KP_Down:        VirtualKey := VK_DOWN;

    GDK_KP_Page_Up:     VirtualKey := VK_PRIOR;

    GDK_KP_Page_Down:   VirtualKey := VK_NEXT;

    GDK_KP_End:         VirtualKey := VK_END;



    GDK_Num_Lock:       VirtualKey := VK_NUMLOCK;

    GDK_KP_F1:          VirtualKey := VK_F1;

    GDK_KP_F2:          VirtualKey := VK_F2;

    GDK_KP_F3:          VirtualKey := VK_F3;

    GDK_KP_F4:          VirtualKey := VK_F4;



    GDK_KP_Equal:      

      begin

        VirtualKey := $BB;

        if not CtrlDown then KeyCode := Ord('=');

      end;

    GDK_KP_Multiply:      

      begin

        VirtualKey := VK_MULTIPLY;

        if not CtrlDown then KeyCode := Ord('*');

      end;

    GDK_KP_Add:      

      begin

        VirtualKey := VK_ADD;

        if not CtrlDown then KeyCode := Ord('+');

      end;

    GDK_KP_Separator:      

      begin

        VirtualKey := VK_SEPARATOR;

      end;

    GDK_KP_Subtract:      

      begin

        VirtualKey := VK_SUBTRACT;

        if not CtrlDown then KeyCode := Ord('-');

      end;

    GDK_KP_Decimal:      

      begin

        VirtualKey := VK_DECIMAL;

        if not CtrlDown then KeyCode := Ord('.');

      end;

    GDK_KP_Divide:      

      begin

        VirtualKey := VK_DIVIDE;

        Extended := True;

        if not CtrlDown then KeyCode := Ord('/');

      end;

    GDK_KP_0..GDK_KP_9: 

      begin

        VirtualKey := VK_NUMPAD0 + (Event^.KeyVal - GDK_KP_0);

        if not CtrlDown then KeyCode := Ord('0') + (Event^.KeyVal - GDK_KP_0);

      end;



    GDK_BackSpace:      VirtualKey := VK_BACK;





    GDK_Clear_Key:      VirtualKey := VK_CLEAR;

    GDK_Pause:          VirtualKey := VK_PAUSE;

    GDK_Scroll_Lock:    VirtualKey := VK_SCROLL;

    GDK_Sys_Req:        VirtualKey := VK_SNAPSHOT;

    GDK_Escape:         VirtualKey := VK_ESCAPE;

    GDK_Delete_Key:     VirtualKey := VK_DELETE;

    

    GDK_Kanji:          VirtualKey := VK_KANJI;



    GDK_Select:         VirtualKey := VK_SELECT;

    GDK_Print:          VirtualKey := VK_PRINT;

    GDK_Execute:        VirtualKey := VK_EXECUTE;



    GDK_Menu:           VirtualKey := VK_MENU;

    GDK_Cancel:         VirtualKey := VK_CANCEL;

    GDK_Help:           VirtualKey := VK_HELP;

    GDK_Break:          VirtualKey := VK_CANCEL;

    GDK_Mode_switch:    VirtualKey := VK_MODECHANGE;

    GDK_Caps_Lock:      VirtualKey := VK_CAPITAL;

    GDK_Shift_L:

      begin

        VirtualKey := VK_SHIFT;

      end;

    GDK_Shift_R:

      begin

        VirtualKey := VK_SHIFT;

        Extended := True;

      end;

    GDK_Control_L:

      begin

        VirtualKey := VK_CONTROL;

      end;

    GDK_Control_R:

      begin

        VirtualKey := VK_CONTROL;

        Extended := True;

      end;

    GDK_Alt_L:

      begin

        SysKey := True;

        VirtualKey:= VK_MENU; 

      end; 

    GDK_Alt_R:

      begin

        SysKey := True;

        VirtualKey:= VK_MENU; 

      end; 

    

    GDK_F1..GDK_F24:    VirtualKey := VK_F1 + (Event^.KeyVal - GDK_F1);

  end;

end;



{This routine was taken from the Lazarus LCL, and then further modified by myself}

Function OnKeyUpDown(Widget: Pointer; Event : PGDKEventKey; Data: Pointer) : Boolean; cdecl;

var

  Msg: TWMKey;

  Code,

  KeyCode: Word;

  Flags: Integer;

  Toggle, Extended, SysKey: Boolean;

begin

  GetGTKKeyInfo(Event, KeyCode, Msg.CharCode, SysKey, Extended, Toggle);

  

  Flags := 0;

  

  If Extended then

    Flags := KF_Extended;

  

  if ((Event^.State and GDK_Control_MASK) <> 0) or 

    (msg.CharCode = vk_Control) 

  then 

    Flags := Flags or KF_CTRLDown;

  

  if SysKey then 

    Flags := Flags or KF_ALTDOWN;

  

  if ((Event^.State and GDK_Shift_MASK) <> 0) or 

    (msg.CharCode = vk_Shift) 

  then 

    Flags := Flags or KF_ShiftDown;





  Msg.KeyData := $00000000;

  msg.Result := 0;

  case Event^.theType of



    GDK_KEY_RELEASE:

      begin

        if SysKey then 

	  Msg.msg := WM_SYSKEYUP

        else 

	  Msg.msg := WM_KEYUP;



        Flags := Flags or KF_UP or KF_REPEAT;

        Msg.KeyData := Msg.KeyData or (Flags shl 16) or $0001;

        If Data <> nil then

          CBH(Msg.msg,[Data, @Msg],nil);



      end;

      

    GDK_KEY_PRESS:

      begin

        if SysKey then 

	    Msg.msg := WM_SYSKEYDOWN

        else 

	    Msg.msg := WM_KEYDOWN;

        Msg.KeyData := Msg.KeyData or (Flags shl 16) or $0001;

	Code := Msg.CharCode;

        If Data <> nil then

          CBH(Msg.msg,[Data, @Msg],nil);

        If Msg.CharCode <> Code then begin

	    KeyCode := $FFFF;

   	    {$IfNDef Win32}

          Event^.theString[0] := #0;

   	    {$EndIf}

	    Event^.KeyVal := 0;

        end;

        if KeyCode <> $FFFF

        then begin

          if SysKey then

	    Msg.msg := WM_SYSCHAR

          else

	    Msg.msg := WM_CHAR;

          Msg.CharCode := KeyCode;

          If Data <> nil then

            CBH(Msg.msg,[Data, @Msg],nil);

	  If Msg.CharCode <> KeyCode then

            Event^.theString[0] := Char(Msg.CharCode);

	end;

      end;

  end;

  Result := True;

end;



Procedure OnDestroy(Widget : Pointer; Data : Pointer); cdecl;

var

  Msg : TMessage;

begin

  Msg.Msg := WM_CLOSE;

  If CBH <> nil then

    CBH(WM_CLOSE,[Data, @Msg], nil);

end;



Procedure OnClicked(Widget : Pointer; Data : Pointer); cdecl;

var

  Msg : TMessage;

begin

  Msg.Msg := WM_Command;

  If CBH <> nil then

    CBH(WM_Command,[Data, @Msg], nil);

end;



{Procedure OnPressed(Widget : Pointer; Data : Pointer); cdecl;

var

  Dummy : Pointer;

begin

  Dummy := nil;

  If CBH <> nil then

    CBH('OnPressed',[Widget, Data], Dummy);

end;



Procedure OnResize(Widget : Pointer; Blah, Data : Pointer); cdecl;

var

  Dummy : Pointer;

begin

  Dummy := nil;

  If CBH <> nil then

    CBH('OnResize',[Widget, Data], Dummy);

end;



Procedure OnReleased(Widget : Pointer; Data : Pointer); cdecl;

var

  Dummy : Pointer;

begin

  Dummy := nil;

  If CBH <> nil then

    CBH('OnReleased',[Widget, Data], Dummy);

end;



Procedure OnEnter(Widget : Pointer; Data : Pointer); cdecl;

var

  Dummy : Pointer;

begin

  Dummy := nil;

  If CBH <> nil then

    CBH('OnEnter',[Widget, Data], Dummy);

end;



Function OnMouseMove(Widget : Pointer; Event : Pointer; Data : Pointer) : Boolean; cdecl;

var

  Dummy : Pointer;

begin

  Result := False;

  Dummy := nil;

  If CBH <> nil then

    CBH('OnMouseMove',[Widget, Data], Dummy);

end;



Function OnFocusEnter(Widget : Pointer; Event : Pointer; Data : Pointer) : Boolean; cdecl;

var

  Dummy : Pointer;

begin

  Result := True;

  Dummy := nil;

  If CBH <> nil then

    CBH('OnFocusEnter',[Widget, Data], Dummy);

end;



Function OnButtonPress(Widget : Pointer;  ButtonData : PGDKEventButton; Data : Pointer) : Boolean; cdecl;

var

  Dummy : Pointer;

begin

  Result := True;

  Dummy := nil;

  If ButtonData^.Button = 1 then

    If CBH <> nil then

      If ButtonData^.theType = GDK_2Button_Press then

        CBH('OnDblClick',[Widget, Data], Dummy)

      else  

        If ButtonData^.theType = GDK_Button_Press then

          CBH('OnClick',[Widget, Data], Dummy)

end;



Function OnFocusExit(Widget : Pointer; Event : Pointer; Data : Pointer) : Boolean; cdecl;

var

  Dummy : Pointer;

begin

  Result := True;

  Dummy := nil;

  If CBH <> nil then

    CBH('OnFocusExit',[Widget, Data], Dummy);

end;



Procedure OnChanged(Widget : Pointer; Data : Pointer); cdecl;

var

  Dummy : Pointer;

begin

  Dummy := nil;

  If CBH <> nil then

    CBH('OnChanged',[Widget, Data], Dummy);

end;



Procedure OnLeave(Widget : Pointer; Data : Pointer); cdecl;

var

  Dummy : Pointer;

begin

  Dummy := nil;

  If CBH <> nil then

    CBH('OnLeave',[Widget, Data], Dummy);

end;

       }

end.

