program GWOLTest;
{$IfDef FPC}
  {$Mode Delphi}
{$endIF}
{$Apptype Console}
{$Include WOLDefs.Inc}
uses
  {$IFDef GTKWIN}
  CPWindows,GTKWindows,
  GDK,GTK,
  {$Else}
  Windows,
  {$EndIF}
  {$IFNDEF FPC}Messages,{$ENDIF}
  WOLDefs,
  WOLPen,
  WOLFont,WOLBrush,
  WOLCanva,WolDBG;

var 
  WControl,
  WControl2 : hWnd;
  Canvas : TWOLCanvas;
  FBeginColor,FEndColor : Longint;

Function Point(X,Y : Integer) : T_Point;
begin
  Result.X := X;
  Result.Y := Y;
end;

Procedure Winpaint(Handle : hDC);
var
  I : integer;
  Width,Height : Integer;
  ar : Array[0..4] of T_Point;
  arect : TRect;
  
  Procedure GradientColor(GPosition,GTotal : integer);
  var
    R, G, B : Byte;
  begin
    R := GetRValue(FBeginColor);
    G := GetGValue(FBeginColor);
    B := GetBValue(FBeginColor);

    R := R + (GPosition*(GetRValue(FEndColor) - R) div GTotal);
    G := G + (GPosition*(GetGValue(FEndColor) - G) div GTotal);
    B := B + (GPosition*(GetBValue(FEndColor) - B) div GTotal);

    Canvas.Brush.Color := RGB(R,G,B);
  end;

begin
  Width := 300;
  Height := 400;
  Canvas.Handle := Handle;
  Canvas.Pen.Style := WOL_psSolid;
  Canvas.Pen.Mode := wol_pmCopy;
  Canvas.Brush.Style := WOL_bsSolid;
  for I := 0 to 255 do begin
    GradientColor(I,255);
    Canvas.FillRect(GetRect(0,(I*Height div 256),Width,
                    ((I + 1)*Height div 256)));
  end; 
  Canvas.Pen.Width := 0;
  Canvas.Pen.Color := $00FF00;
  Canvas.Pen.Style := Wol_PSDashDotDot;
  Canvas.Brush.Color := $0000FF;
  Canvas.Rectangle(35,35,200,200);
  Canvas.Brush.Style := WOL_bsFDiagonal;
  Canvas.Brush.Color := $F0000F;
  Canvas.Pie(35,35,200,200,0,0,200,350);
  Canvas.Brush.Style := WOL_bsDiagCross;
  Canvas.Brush.Color := $AAAA00;
  Canvas.Pie(200,35,400,235,0,0,200,350);
  Canvas.Brush.Style := WOL_bsSolid;
  Canvas.Brush.Color := $0000FF;
  Canvas.Chord(200,35,400,235,0,0,200,350);
  Canvas.Brush.Color := $FF00FF;
  Canvas.Brush.Style := WOL_bsCross;
  Canvas.Ellipse(35,35,200,275);
 // Canvas.DrawFocusRect(GetRect(40,40,195,195));
  Canvas.RoundRect(40,145,295,295);
  ar[0] := Point(5,200);
  ar[1] := Point(15,200);
  ar[2] := Point(25, 215);
  ar[3] := Point(15, 300);
  ar[4] := Point(5, 275);
  Canvas.Brush.Style := WOL_bsDiagCross;
  Canvas.Brush.Color := $AAAA00;
  Canvas.Polygon(ar);
  Canvas.Brush.color := $FF0000;
  Canvas.Brush.Style := WOL_bsSolid;
  Canvas.Font.FontName := 'Times';
  Canvas.Font.Size := 14;
  Canvas.Font.Style := [wol_fsUnderline,wol_fsBold,wol_fsItalic,wol_fsStrikeOut];
  Canvas.TextRect(Rect(155,0,235,300),0,0,'WHATEVER you say!',True,True);
  arect := Rect(155,0,235,300);
//  InvertRect(Handle,aRect);
  Canvas.Handle := 0;
end;

  function GetTextBuf(Handle : hWnd; Buffer: PChar; BufSize: Integer): Integer;
  begin
    Result := DefWindowProc(Handle,WM_GETTEXT,BufSize, longint(Buffer));
  end;

  function GetText(Handle : hWnd): String;
  var
    Len: Integer;
  begin
    Len := DefWindowProc(Handle, WM_GETTEXTLENGTH,0,0);
    SetLength(Result, Len);
    if Len <> 0 then 
      GetTextBuf(Handle, Pointer(Result), Len + 1);  
  end;

  procedure SetTextBuf(Handle : hWnd; Buffer: PChar);
  begin
    DefWindowProc(Handle, WM_SETTEXT, 0, Longint(Buffer));
  end;

  procedure SetText(Handle : hWnd; const Value: String);
  begin
    if GetText(Handle) <> Value then 
      SetTextBuf(Handle, PChar(Value));
  end;

var
  OldWindProc : Pointer;

  function TestFormProc(Wnd: HWND; aMsg: UINT; w_Param: WPARAM;
    l_Param: LPARAM): LRESULT; stdcall; export;
  var
    DC : hdc;
    ps : TPaintStruct;
    pnt : TPoint;
  begin
    Result := 0;
    Case aMsg of
      WM_Close:
        begin
          PostQuitMessage(0);
        end;
      WM_Command:
        If l_Param = wControl2 then begin
          GetCursorPos(pnt);
          writeln(pnt.X,' ',pnt.Y);
          MessageBox(Wnd,'You Clicked a Button. ' + #13#10
            + 'And this is the exceptionally long and very pointless '
            + 'message which is being displayed as a result.'
            ,'GWOLTest', MB_OK);
          SetCursorPos(5,4);
        end;
      WM_Paint:
        begin
          DC:=BeginPaint(wnd,{$IfDef FPC}@{$EndIF}ps);
          WinPaint(DC);
          EndPaint(wnd,ps);
        end;
    end;
    Result:=CallWindowProc(OldWindProc, Wnd, aMsg, w_Param, l_Param);
  end;

var
  GWOLTestWindow: TWndClass = (
    style : CS_DBLCLKS or CS_HREDRAW or CS_VREDRAW;
    lpfnWndProc  : @DefWindowProc;
    cbClsExtra   : 0;
    cbWndExtra   : 0;
    hInstance    : 0;
    hIcon        : 0;
    hCursor      : 0;
    hbrBackground: 0;
    lpszMenuName : nil;
    lpszClassName: 'GWOLTestWindow' );


{$IFNDef GTKWIN}
var
  AMessage: Msg;
{$EndIf}
begin
  GWOLTestWindow.hInstance:=HInstance;
  GWOLTestWindow.hCursor:=LoadCursor(0, IDC_ARROW);
  GWOLTestWindow.hbrBackground:=GetStockObject(Gray_BRUSH);
  RegisterClass(GWOLTestWindow);
  WControl:=CreateWindowEx( WS_EX_PALETTEWINDOW or WS_EX_CONTROLPARENT,
                            GWOLTestWindow.lpszClassName,
                            'Test Window',
                            WS_VISIBLE or WS_CAPTION or WS_POPUP or WS_THICKFRAME or WS_SYSMENU,
                            0, 0, 300, 400,
                            0, 0,
                            HInstance, nil);
  FBeginColor := $FF0000;
  FEndColor := $0;
  Canvas := TWOLCanvas.Create;
  WControl2:=CreateWindowEx( 0, 'Button', 'Testing',
                             WS_VISIBLE or WS_CHILD,
                             25, 24, 75, 24,
                             WControl, 0, HInstance, nil);
  OldwindProc := Pointer(SetWindowLong(WControl, GWL_WNDPROC, Longint(@TestFormProc)));
  ShowWindow(WControl, sw_Normal);
  UpdateWindow(WControl);
//  WinDebug(WControl);
  {$IfDef GTKWIN}
  Gtk_main();
  {$Else}
   while GetMessage({$IfDef FPC}@{$EndIF}AMessage, 0, 0, 0) do begin
    TranslateMessage(AMessage);
    DispatchMessage(AMessage);
   end;
  {$EndIf}
end.
