{

  This program is distributed in the hope that it will be useful,

  but WITHOUT ANY WARRANTY; without even the implied warranty of

  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the

  GNU General Public License (http://www.gnu.org/copyleft/gpl.html)

  for more details

  

************************************************************************

  WOL - Window Objects Library - version 0.00.3



  This library is a framework for Windows/GTK programming with the Free

  Pascal Compiler. The main objective is to make porting programs

  between Windows and Linux easier by using the same framework.



  If you find bugs or want colaborate with us to improve, please report

  to authors. It was originally writen by Carlos Alberto de Oliveira

  (carlosnatal@bol.com.br) and is maintened by the following authors:



  Carlos Alberto de Oliveira - carlosnatal@bol.com.br

  Andrew Johnson             - aj_genius@hotmail.com



  Missing you... Visit http://www.olhodetigre.hpg.com.br

                       http://www.freepascal.org

**************************************************************************

FileName : WOLCDlg.pp

Current File Version* : .4



Author(s) : Carlos Alberto de Oliveira(carlosnatal@bol.com.br)



Comments  : This File attempts to provide a manual debug.



*See end of file for File history

**************************************************************************

}



{$IFDEF FPC}

  {$MODE DELPHI}

{$ENDIF}



unit wolDBG;



interface



{$Include WOLDefs.Inc}

Uses

  Classes,

  {$IFDef GTKWIN}

  CPWindows,GTKWindows,

  {$Else}

  Windows,

  {$EndIF}

  SysUtils,

  wolDefs

  {$IFNDEF FPC}, Messages{$ENDIF};



var _DebugNow:Boolean     = False;

    ListDebug:TStringList = nil;

    TabDebug :Integer     = 0;

    DebugHnd :HWND        = 0;

    DebugLbl1:HWND        = 0;

    DebugLbl2:HWND        = 0;

    DebugLbl3:HWND        = 0;

    DebugLbl4:HWND        = 0;

    DebugLbl5:HWND        = 0;

    DebugLbl6:HWND        = 0;

    DebugLbl7:HWND        = 0;

    DebugLbl8:HWND        = 0;

    DebugBtnC:HWND        = 0;

    DebugBtnE:HWND        = 0;

    DebugOldW:Pointer     = nil;



procedure debug(s:string);

procedure wmdebug(proc:string; wmMSG:TMessage);

procedure tdebug(p, s:string);



procedure WinDebug(AppHandle:HWND);

procedure SetTextDbg(const S:string; Lbl:Integer);



implementation



function Spaces(n:integer):string;

var i:integer;

begin

  Result:='';

  for i:=1 to n do Result:=Result+' ';

end;



procedure debug(s:string);

var f:Text;

begin

  if not _DebugNow then exit;

  AssignFile(f, 'DEBUG.TXT');

  if fileExists('DEBUG.TXT') then

     Append(f)

  else begin

     Rewrite(f);

     writeln(f, '(C) 2001 Copyright Carlos Alberto de Oliveira');

     writeln(f, '=============================================');

  end;

  writeln(f, Spaces(TabDebug), s);

  flush(f);

  close(f);

end;



const

     NUMERO_MSGS = 201;

type

   tdbg_msg = record

                sMsg : string[50];

                iMsg : LONGINT;

              end;

const

  dbg_msg:array[0..NUMERO_MSGS-1] of tdbg_msg = (

          (sMsg:'WM_NULL';                      iMsg: $0000),

          (sMsg:'WM_CREATE';                    iMsg: $0001),

          (sMsg:'WM_DESTROY';                   iMsg: $0002),

          (sMsg:'WM_MOVE';                      iMsg: $0003),

          (sMsg:'WM_SIZE';                      iMsg: $0005),

          (sMsg:'WM_ACTIVATE';                  iMsg: $0006),

          (sMsg:'WM_SETFOCUS';                  iMsg: $0007),

          (sMsg:'WM_KILLFOCUS';                 iMsg: $0008),

          (sMsg:'WM_ENABLE';                    iMsg: $000A),

          (sMsg:'WM_SETREDRAW';                 iMsg: $000B),

          (sMsg:'WM_SETTEXT';                   iMsg: $000C),

          (sMsg:'WM_GETTEXT';                   iMsg: $000D),

          (sMsg:'WM_GETTEXTLENGTH';             iMsg: $000E),

          (sMsg:'WM_PAINT';                     iMsg: $000F),

          (sMsg:'WM_CLOSE';                     iMsg: $0010),

          (sMsg:'WM_QUERYENDSESSION';           iMsg: $0011),

          (sMsg:'WM_QUIT';                      iMsg: $0012),

          (sMsg:'WM_QUERYOPEN';                 iMsg: $0013),

          (sMsg:'WM_ERASEBKGND';                iMsg: $0014),

          (sMsg:'WM_SYSCOLORCHANGE';            iMsg: $0015),

          (sMsg:'WM_ENDSESSION';                iMsg: $0016),

          (sMsg:'WM_SYSTEMERROR';               iMsg: $0017),

          (sMsg:'WM_SHOWWINDOW';                iMsg: $0018),

          (sMsg:'WM_CTLCOLOR';                  iMsg: $0019),

          (sMsg:'WM_WININICHANGE';              iMsg: $001A),

          (sMsg:'WM_DEVMODECHANGE';             iMsg: $001B),

          (sMsg:'WM_ACTIVATEAPP';               iMsg: $001C),

          (sMsg:'WM_FONTCHANGE';                iMsg: $001D),

          (sMsg:'WM_TIMECHANGE';                iMsg: $001E),

          (sMsg:'WM_CANCELMODE';                iMsg: $001F),

          (sMsg:'WM_SETCURSOR';                 iMsg: $0020),

          (sMsg:'WM_MOUSEACTIVATE';             iMsg: $0021),

          (sMsg:'WM_CHILDACTIVATE';             iMsg: $0022),

          (sMsg:'WM_QUEUESYNC';                 iMsg: $0023),

          (sMsg:'WM_GETMINMAXINFO';             iMsg: $0024),

          (sMsg:'WM_PAINTICON';                 iMsg: $0026),

          (sMsg:'WM_ICONERASEBKGND';            iMsg: $0027),

          (sMsg:'WM_NEXTDLGCTL';                iMsg: $0028),

          (sMsg:'WM_SPOOLERSTATUS';             iMsg: $002A),

          (sMsg:'WM_DRAWITEM';                  iMsg: $002B),

          (sMsg:'WM_MEASUREITEM';               iMsg: $002C),

          (sMsg:'WM_DELETEITEM';                iMsg: $002D),

          (sMsg:'WM_VKEYTOITEM';                iMsg: $002E),

          (sMsg:'WM_CHARTOITEM';                iMsg: $002F),

          (sMsg:'WM_SETFONT';                   iMsg: $0030),

          (sMsg:'WM_GETFONT';                   iMsg: $0031),

          (sMsg:'WM_SETHOTKEY';                 iMsg: $0032),

          (sMsg:'WM_GETHOTKEY';                 iMsg: $0033),

          (sMsg:'WM_QUERYDRAGICON';             iMsg: $0037),

          (sMsg:'WM_COMPAREITEM';               iMsg: $0039),

          (sMsg:'WM_COMPACTING';                iMsg: $0041),

          (sMsg:'WM_COMMNOTIFY';                iMsg: $0044),

          (sMsg:'WM_WINDOWPOSCHANGING';         iMsg: $0046),

          (sMsg:'WM_WINDOWPOSCHANGED';          iMsg: $0047),

          (sMsg:'WM_POWER';                     iMsg: $0048),

          (sMsg:'WM_COPYDATA';                  iMsg: $004A),

          (sMsg:'WM_CANCELJOURNAL';             iMsg: $004B),

          (sMsg:'WM_NOTIFY';                    iMsg: $004E),

          (sMsg:'WM_INPUTLANGCHANGEREQUEST';    iMsg: $0050),

          (sMsg:'WM_INPUTLANGCHANGE';           iMsg: $0051),

          (sMsg:'WM_TCARD';                     iMsg: $0052),

          (sMsg:'WM_HELP';                      iMsg: $0053),

          (sMsg:'WM_USERCHANGED';               iMsg: $0054),

          (sMsg:'WM_NOTIFYFORMAT';              iMsg: $0055),

          (sMsg:'WM_CONTEXTMENU';               iMsg: $007B),

          (sMsg:'WM_STYLECHANGING';             iMsg: $007C),

          (sMsg:'WM_STYLECHANGED';              iMsg: $007D),

          (sMsg:'WM_DISPLAYCHANGE';             iMsg: $007E),

          (sMsg:'WM_GETICON';                   iMsg: $007F),

          (sMsg:'WM_SETICON';                   iMsg: $0080),

          (sMsg:'WM_NCCREATE';                  iMsg: $0081),

          (sMsg:'WM_NCDESTROY';                 iMsg: $0082),

          (sMsg:'WM_NCCALCSIZE';                iMsg: $0083),

          (sMsg:'WM_NCHITTEST';                 iMsg: $0084),

          (sMsg:'WM_NCPAINT';                   iMsg: $0085),

          (sMsg:'WM_NCACTIVATE';                iMsg: $0086),

          (sMsg:'WM_GETDLGCODE';                iMsg: $0087),

          (sMsg:'WM_NCMOUSEMOVE';               iMsg: $00A0),

          (sMsg:'WM_NCLBUTTONDOWN';             iMsg: $00A1),

          (sMsg:'WM_NCLBUTTONUP';               iMsg: $00A2),

          (sMsg:'WM_NCLBUTTONDBLCLK';           iMsg: $00A3),

          (sMsg:'WM_NCRBUTTONDOWN';             iMsg: $00A4),

          (sMsg:'WM_NCRBUTTONUP';               iMsg: $00A5),

          (sMsg:'WM_NCRBUTTONDBLCLK';           iMsg: $00A6),

          (sMsg:'WM_NCMBUTTONDOWN';             iMsg: $00A7),

          (sMsg:'WM_NCMBUTTONUP';               iMsg: $00A8),

          (sMsg:'WM_NCMBUTTONDBLCLK';           iMsg: $00A9),

          

          (sMsg:'BM_GETCHECK';                  iMsg: $00F0),

          (sMsg:'BM_SETCHECK';                  iMsg: $00F1),

          (sMsg:'BM_GETSTATE';                  iMsg: $00F2),

          (sMsg:'BM_SETSTATE';                  iMsg: $00F3),

          (sMsg:'BM_SETSTYLE';                  iMsg: $00F4),

          (sMsg:'WM_SYNCPAINT';                 iMsg: $0088),



          (sMsg:'WM_KEYDOWN';                   iMsg: $0100),

          (sMsg:'WM_KEYFIRST';                  iMsg: $0100),

          (sMsg:'WM_KEYUP';                     iMsg: $0101),

          (sMsg:'WM_CHAR';                      iMsg: $0102),

          (sMsg:'WM_DEADCHAR';                  iMsg: $0103),

          (sMsg:'WM_SYSKEYDOWN';                iMsg: $0104),

          (sMsg:'WM_SYSKEYUP';                  iMsg: $0105),

          (sMsg:'WM_SYSCHAR';                   iMsg: $0106),

          (sMsg:'WM_SYSDEADCHAR';               iMsg: $0107),

          (sMsg:'WM_KEYLAST';                   iMsg: $0108),

          (sMsg:'WM_INITDIALOG';                iMsg: $0110),

          (sMsg:'WM_COMMAND';                   iMsg: $0111),

          (sMsg:'WM_SYSCOMMAND';                iMsg: $0112),

          (sMsg:'WM_TIMER';                     iMsg: $0113),

          (sMsg:'WM_HSCROLL';                   iMsg: $0114),

          (sMsg:'WM_VSCROLL';                   iMsg: $0115),

          (sMsg:'WM_INITMENU';                  iMsg: $0116),

          (sMsg:'WM_INITMENUPOPUP';             iMsg: $0117),

          (sMsg:'WM_MENUSELECT';                iMsg: $011F),

          (sMsg:'WM_MENUCHAR';                  iMsg: $0120),

          (sMsg:'WM_ENTERIDLE';                 iMsg: $0121),

          (sMsg:'WM_UNINITMENUPOPUP';           iMsg: $0125),

          (sMsg:'WM_QUERYUISTATE';              iMsg: $0129),

          (sMsg:'WM_CTLCOLORMSGBOX';            iMsg: $0132),

          (sMsg:'WM_CTLCOLOREDIT';              iMsg: $0133),

          (sMsg:'WM_CTLCOLORLISTBOX';           iMsg: $0134),

          (sMsg:'WM_CTLCOLORBTN';               iMsg: $0135),

          (sMsg:'WM_CTLCOLORDLG';               iMsg: $0136),

          (sMsg:'WM_CTLCOLORSCROLLBAR';         iMsg: $0137),

          (sMsg:'WM_CTLCOLORSTATIC';            iMsg: $0138),

          (sMsg:'WM_MOUSEMOVE';                 iMsg: $0200),

          (sMsg:'WM_MOUSEFIRST';                iMsg: $0200),

          (sMsg:'WM_LBUTTONDOWN';               iMsg: $0201),

          (sMsg:'WM_LBUTTONUP';                 iMsg: $0202),

          (sMsg:'WM_LBUTTONDBLCLK';             iMsg: $0203),

          (sMsg:'WM_RBUTTONDOWN';               iMsg: $0204),

          (sMsg:'WM_RBUTTONUP';                 iMsg: $0205),

          (sMsg:'WM_RBUTTONDBLCLK';             iMsg: $0206),

          (sMsg:'WM_MBUTTONDOWN';               iMsg: $0207),

          (sMsg:'WM_MBUTTONUP';                 iMsg: $0208),

          (sMsg:'WM_MBUTTONDBLCLK';             iMsg: $0209),

          (sMsg:'WM_MOUSEWHEEL';                iMsg: $020A),

          (sMsg:'WM_MOUSELAST';                 iMsg: $020A),

          (sMsg:'WM_PARENTNOTIFY';              iMsg: $0210),

          (sMsg:'WM_ENTERMENULOOP';             iMsg: $0211),

          (sMsg:'WM_EXITMENULOOP';              iMsg: $0212),

          (sMsg:'WM_NEXTMENU';                  iMsg: $0213),

          (sMsg:'WM_SIZING';                    iMsg: $0214),

          (sMsg:'WM_CAPTURECHANGED';            iMsg: $0215),

          (sMsg:'WM_MOVING';                    iMsg: $0216),

          (sMsg:'WM_POWERBROADCAST';            iMsg: $0218),

          (sMsg:'WM_DEVICECHANGE';              iMsg: $0219),

          (sMsg:'WM_IME_STARTCOMPOSITION';      iMsg: $010D),

          (sMsg:'WM_IME_ENDCOMPOSITION';        iMsg: $010E),

          (sMsg:'WM_IME_COMPOSITION';           iMsg: $010F),

          (sMsg:'WM_IME_KEYLAST';               iMsg: $010F),

          (sMsg:'WM_IME_SETCONTEXT';            iMsg: $0281),

          (sMsg:'WM_IME_NOTIFY';                iMsg: $0282),

          (sMsg:'WM_IME_CONTROL';               iMsg: $0283),

          (sMsg:'WM_IME_COMPOSITIONFULL';       iMsg: $0284),

          (sMsg:'WM_IME_SELECT';                iMsg: $0285),

          (sMsg:'WM_IME_CHAR';                  iMsg: $0286),

          (sMsg:'WM_IME_KEYDOWN';               iMsg: $0290),

          (sMsg:'WM_IME_KEYUP';                 iMsg: $0291),

          (sMsg:'WM_MDICREATE';                 iMsg: $0220),

          (sMsg:'WM_MDIDESTROY';                iMsg: $0221),

          (sMsg:'WM_MDIACTIVATE';               iMsg: $0222),

          (sMsg:'WM_MDIRESTORE';                iMsg: $0223),

          (sMsg:'WM_MDINEXT';                   iMsg: $0224),

          (sMsg:'WM_MDIMAXIMIZE';               iMsg: $0225),

          (sMsg:'WM_MDITILE';                   iMsg: $0226),

          (sMsg:'WM_MDICASCADE';                iMsg: $0227),

          (sMsg:'WM_MDIICONARRANGE';            iMsg: $0228),

          (sMsg:'WM_MDIGETACTIVE';              iMsg: $0229),

          (sMsg:'WM_MDISETMENU';                iMsg: $0230),

          (sMsg:'WM_ENTERSIZEMOVE';             iMsg: $0231),

          (sMsg:'WM_EXITSIZEMOVE';              iMsg: $0232),

          (sMsg:'WM_DROPFILES';                 iMsg: $0233),

          (sMsg:'WM_MDIREFRESHMENU';            iMsg: $0234),

          (sMsg:'WM_MOUSEHOVER';                iMsg: $02A1),

          (sMsg:'WM_MOUSELEAVE';                iMsg: $02A3),

          (sMsg:'WM_CUT';                       iMsg: $0300),

          (sMsg:'WM_COPY';                      iMsg: $0301),

          (sMsg:'WM_PASTE';                     iMsg: $0302),

          (sMsg:'WM_CLEAR';                     iMsg: $0303),

          (sMsg:'WM_UNDO';                      iMsg: $0304),

          (sMsg:'WM_RENDERFORMAT';              iMsg: $0305),

          (sMsg:'WM_RENDERALLFORMATS';          iMsg: $0306),

          (sMsg:'WM_DESTROYCLIPBOARD';          iMsg: $0307),

          (sMsg:'WM_DRAWCLIPBOARD';             iMsg: $0308),

          (sMsg:'WM_PAINTCLIPBOARD';            iMsg: $0309),

          (sMsg:'WM_VSCROLLCLIPBOARD';          iMsg: $030A),

          (sMsg:'WM_SIZECLIPBOARD';             iMsg: $030B),

          (sMsg:'WM_ASKCBFORMATNAME';           iMsg: $030C),

          (sMsg:'WM_CHANGECBCHAIN';             iMsg: $030D),

          (sMsg:'WM_HSCROLLCLIPBOARD';          iMsg: $030E),

          (sMsg:'WM_QUERYNEWPALETTE';           iMsg: $030F),

          (sMsg:'WM_PALETTEISCHANGING';         iMsg: $0310),

          (sMsg:'WM_PALETTECHANGED';            iMsg: $0311),

          (sMsg:'WM_HOTKEY';                    iMsg: $0312),

          (sMsg:'WM_PRINT';                     iMsg: $0317),

          (sMsg:'WM_PRINTCLIENT';               iMsg: $0318),

          (sMsg:'WM_HANDHELDFIRST';             iMsg: $0358),

          (sMsg:'WM_HANDHELDLAST';              iMsg: $035F),

          (sMsg:'WM_PENWINFIRST';               iMsg: $0380),

          (sMsg:'WM_PENWINLAST';                iMsg: $038F),

          (sMsg:'WM_COALESCE_FIRST';            iMsg: $0390),

          (sMsg:'WM_COALESCE_LAST';             iMsg: $039F));





procedure wmdebug(proc:string; wmMSG:TMessage);

var f:Text;

    i:integer;

    a:boolean;

begin

  if not _DebugNow then exit;

  if wmMSG.msg = WM_SETCURSOR then Exit;

  if wmMSG.msg = WM_MOUSEMOVE then Exit;

  if wmMSG.msg = WM_NCHITTEST then Exit;

  {if wmMSG.msg <> WM_ERASEBKGND then Exit; }

  _DebugNow:=False;

  AssignFile(f, 'DEBUG.TXT');

  if fileExists('DEBUG.TXT') then

     Append(f)

  else begin

     Rewrite(f);

     writeln(f, '(C) 2001 Copyright Carlos Alberto de Oliveira');

     writeln(f, '=============================================');

  end;

  a:=False;

  for i:=0 to NUMERO_MSGS-1 do if wmMSG.Msg = dbg_msg[i].iMsg then begin

    writeln(f, 'Local     : ', proc);

    writeln(f, 'Mensagem  : ', dbg_msg[i].sMsg:30, ' = $'+inttohex(wmMSG.Msg, 4));

    writeln(f, ' *WParam  : ', wmMSG.WParam  :8);

    writeln(f, ' +WParamLo: ', wmMsg.WParamLo:8);

    writeln(f, ' +WParamHi: ', wmMsg.WParamHi:8);

    writeln(f, ' *LParam  : ', wmMSG.LParam  :8);

    writeln(f, ' +LParamLo: ', wmMsg.LParamLo:8);

    writeln(f, ' +LParamHi: ', wmMsg.LParamHi:8);

    writeln(f, '------------------------------------------------------');

    SetTextDbg('Local     : '+proc, 1);

    SetTextDbg('Mensagem  : '+dbg_msg[i].sMsg+' = $'+inttohex(wmMSG.Msg, 4), 2);

    SetTextDbg(' *WParam  : '+inttostr(wmMSG.WParam), 3);

    SetTextDbg(' +WParamLo: '+inttostr(wmMsg.WParamLo), 4);

    SetTextDbg(' +WParamHi: '+inttostr(wmMsg.WParamHi), 5);

    SetTextDbg(' *LParam  : '+inttostr(wmMSG.LParam), 6);

    SetTextDbg(' +LParamLo: '+inttostr(wmMsg.LParamLo), 7);

    SetTextDbg(' +LParamHi: '+inttostr(wmMsg.LParamHi), 8);

    a:=True;

    break;

  end;

  if not a then begin

     writeln(f, 'Local     : ', proc);

     writeln(f, 'Mensagem  : ', 'DESCONHECIDA':30, ' = $'+inttohex(wmMSG.Msg, 4));

     writeln(f, ' *WParam  : ', wmMSG.WParam  :8);

     writeln(f, ' +WParamLo: ', wmMsg.WParamLo:8);

     writeln(f, ' +WParamHi: ', wmMsg.WParamHi:8);

     writeln(f, ' *LParam  : ', wmMSG.LParam  :8);

     writeln(f, ' +LParamLo: ', wmMsg.LParamLo:8);

     writeln(f, ' +LParamHi: ', wmMsg.LParamHi:8);

     writeln(f, '------------------------------------------------------');

  end;

  flush(f);

  close(f);

  _DebugNow:=True;

end;



procedure tdebug(p, s:string);

var f:Text;

    i:integer;

    a:boolean;

begin

  if not _DebugNow then exit;

  _DebugNow:=False;

  AssignFile(f, 'DEBUG.TXT');

  if fileExists('DEBUG.TXT') then

     Append(f)

  else begin

     Rewrite(f);

     writeln(f, '(C) 2001 Copyright Carlos Alberto de Oliveira');

     writeln(f, '=============================================');

  end;

  a:=True;

  i:=ListDebug.IndexOf(p);

  if (i > -1) and (s = '-') then begin

     dec(TabDebug, 4);

     ListDebug.Delete(i);

     a:=False;

     end

  else

     ListDebug.Add(p);

  writeln(f, Spaces(TabDebug), '*** ', p, ' *** :', s);

  if a then inc(TabDebug, 4);

  flush(f);

  close(f);

  _DebugNow:=True;

end;



var  WOLDebugWindow: TWndClass = ( style        : CS_DBLCLKS or CS_HREDRAW or CS_VREDRAW;

                                   lpfnWndProc  : @DefWindowProc;

                                   cbClsExtra   : 0;

                                   cbWndExtra   : 0;

                                   hInstance    : 0;

                                   hIcon        : 0;

                                   hCursor      : 0;

                                   hbrBackground: 0;

                                   lpszMenuName : nil;

                                   lpszClassName: 'WOLDBGWindow' );



function  WOLDBGProc(Win:HWND; Mensagem:UINT; w_Param:wParam; l_Param:lParam): LRESULT; stdcall; export;

begin

  Result:=0;

  case Mensagem of

       WM_LBUTTONDOWN : begin

                          {$INCLUDE WINPROC.INC}.SetFocus(Win);

                          Exit;

                        end;

       WM_COMMAND     : begin

                          if l_Param = DebugBtnC then

                             {$INCLUDE WINPROC.INC}.DestroyWindow(Win)

                          else if l_Param = DebugBtnE then begin

                             if fileExists('DEBUG.TXT') then DeleteFile('DEBUG.TXT');

                             SetTextDbg('*', 1);

                             SetTextDbg('*', 2);

                             SetTextDbg('*', 3);

                             SetTextDbg('*', 4);

                             SetTextDbg('*', 5);

                             SetTextDbg('*', 6);

                             SetTextDbg('*', 7);

                             SetTextDbg('*', 8);

                             Exit;

                          end;

                        end;    

  end;

  Result:=CallWindowProc(DebugOldW, Win, Mensagem, w_Param, l_Param);

end;



procedure WinDebug(AppHandle:HWND);

var L:Integer;

begin

  if DebugHnd <> 0 then Exit;

  L:=GetSystemMetrics(SM_CXSCREEN) - 330;

  WOLDebugWindow.hInstance:=HInstance;

  WOLDebugWindow.hCursor:=LoadCursor(0, IDC_ARROW);

  WOLDebugWindow.hbrBackground:=GetStockObject(BLACK_BRUSH);

  if {$Include WINPROC.INC}.RegisterClass(WOLDebugWindow) = 0 then Exit;

  DebugHnd:=CreateWindowEx( WS_EX_PALETTEWINDOW or WS_EX_CONTROLPARENT,

                            WOLDebugWindow.lpszClassName,

                            'Debug Window',

                            WS_VISIBLE or WS_POPUP or WS_CAPTION or WS_THICKFRAME or WS_SYSMENU,

                            L, 0, 330, 225,

                            AppHandle, 0,

                            HInstance, nil);

  DebugLbl1:=CreateWindowEx( 0, 'STATIC', '*',

                             WS_VISIBLE or WS_CHILD or SS_LEFT,

                             10, 10, 300, 15,

                             DebugHnd, 0, HInstance, nil);

  DebugLbl2:=CreateWindowEx( 0, 'STATIC', '*',

                             WS_VISIBLE or WS_CHILD or SS_LEFT,

                             10, 31, 300, 15,

                             DebugHnd, 0, HInstance, nil);

  DebugLbl3:=CreateWindowEx( 0, 'STATIC', '*',

                             WS_VISIBLE or WS_CHILD or SS_LEFT,

                             10, 52, 300, 15,

                             DebugHnd, 0, HInstance, nil);

  DebugLbl4:=CreateWindowEx( 0, 'STATIC', '*',

                             WS_VISIBLE or WS_CHILD or SS_LEFT,

                             10, 73, 300, 15,

                             DebugHnd, 0, HInstance, nil);

  DebugLbl5:=CreateWindowEx( 0, 'STATIC', '*',

                             WS_VISIBLE or WS_CHILD or SS_LEFT,

                             10, 94, 300, 15,

                             DebugHnd, 0, HInstance, nil);

  DebugLbl6:=CreateWindowEx( 0, 'STATIC', '*',

                             WS_VISIBLE or WS_CHILD or SS_LEFT,

                             10, 115, 300, 15,

                             DebugHnd, 0, HInstance, nil);

  DebugLbl7:=CreateWindowEx( 0, 'STATIC', '*',

                             WS_VISIBLE or WS_CHILD or SS_LEFT,

                             10, 136, 300, 15,

                             DebugHnd, 0, HInstance, nil);

  DebugLbl8:=CreateWindowEx( 0, 'STATIC', '*',

                             WS_VISIBLE or WS_CHILD or SS_LEFT,

                             10, 157, 300, 15,

                             DebugHnd, 0, HInstance, nil);

  DebugBtnC:=CreateWindowEx( 0, 'BUTTON', 'Close Debug Window',

                             WS_VISIBLE or WS_CHILD or BS_PUSHLIKE,

                             10, 177, 150, 20,

                             DebugHnd, 0, HInstance, nil);

  DebugBtnE:=CreateWindowEx( 0, 'BUTTON', 'Erase Debug Log',

                             WS_VISIBLE or WS_CHILD or BS_PUSHLIKE,

                             161, 177, 150, 20,

                             DebugHnd, 0, HInstance, nil);



  DebugOldW:=Pointer(SetWindowLong(DebugHnd, GWL_WNDPROC, Longint(@WOLDBGProc)));

  ShowWindow(DebugHnd, SW_NORMAL);

  UpdateWindow(DebugHnd);

  debug(Format('Handle de Window DBG = %d', [DebugHnd]));

end;



procedure SetTextDbg(const S:string; Lbl:Integer);

begin

  case Lbl of

       1 : if DebugLbl1 <> 0 then SetWindowText(DebugLbl1, PChar(S));

       2 : if DebugLbl2 <> 0 then SetWindowText(DebugLbl2, PChar(S));

       3 : if DebugLbl3 <> 0 then SetWindowText(DebugLbl3, PChar(S));

       4 : if DebugLbl4 <> 0 then SetWindowText(DebugLbl4, PChar(S));

       5 : if DebugLbl5 <> 0 then SetWindowText(DebugLbl5, PChar(S));

       6 : if DebugLbl6 <> 0 then SetWindowText(DebugLbl6, PChar(S));

       7 : if DebugLbl7 <> 0 then SetWindowText(DebugLbl7, PChar(S));

       8 : if DebugLbl8 <> 0 then SetWindowText(DebugLbl8, PChar(S));

  end;

end;



initialization

  if fileExists('DEBUG.TXT') then DeleteFile('DEBUG.TXT');

  if ListDebug = nil then ListDebug:=TStringList.Create;



end.



{***********************************************************************}

{                            FILE HISTORY                               }

{***********************************************************************}

{Version .5 (Carlos Alberto de Oliveira, jul 15-20 2001)                }

{                                                                       }

{  1.) Created wolDBG unit for debuging                                 }

{  2.) Eliminated dbg.inc                                               }

{  3.) Added wmDebug procedure for debuging Windows messages            }

{  4.) Added _DebugNow flag                                             }

{  5.) Added lDebug procedure for mapping procedures                    }

{***********************************************************************}



