{

  This program is distributed in the hope that it will be useful,

  but WITHOUT ANY WARRANTY; without even the implied warranty of

  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the

  GNU General Public License (http://www.gnu.org/copyleft/gpl.html)

  for more details

  

************************************************************************

  WOL - Window Objects Library - version 0.00.6



  This library is a framework for Windows/GTK programming with the Free

  Pascal Compiler. The main objective is to make porting programs

  between Windows and Linux easier by using the same framework.



  If you find bugs or want colaborate with us to improve, please report

  to authors. It was originally writen by Carlos Alberto de Oliveira

  (carlosnatal@bol.com.br) and is maintened by the following authors:



  Carlos Alberto de Oliveira - carlosnatal@bol.com.br



  Missing you... Visit http://www.olhodetigre.hpg.com.br

                       http://www.freepascal.org

**************************************************************************

FileName : WOLDefs.pp

Current File Version* : .6



Author(s) : Carlos Alberto de Oliveira(carlosnatal@bol.com.br)

            Andrew Johnson(aj_genius@hotmail.com)



Comments  : This File contains WOL definitions and constants to make it

            Delphi/Kylix compatible.



*See end of file for File history

**************************************************************************

}



{$IFDEF FPC}

  {$MODE DELPHI}

{$ENDIF}



unit wolDefs;

interface



{$Include WOLDefs.Inc}

Uses

  Classes,

  {$IFDef GTKWIN}

  CPWindows,GTKWindows

  {$Else}

  Windows

  {$EndIF}

  {$IFNDEF FPC}, Messages{$ENDIF};



type

  {$IFNDef FPC}

    TColor = -$7FFFFFFF-1..$7FFFFFFF;

    hCursor = integer;

  {$Else}

    TColor = $80000000..$7FFFFFFF;

  {$EndIf}

const

     {Instance of Application}

     WOL_Instance : Integer = 0;



     {WOL types flags}

     WOL_NENHUM     =  0;

     WOL_BUTTON     =  1;

     WOL_WINDOW     =  2;

     WOL_MENU       =  3;

     WOL_COMBOBOX   =  4;

     WOL_LISTBOX    =  5;

     WOL_LABEL      =  6;

     WOL_EDIT       =  7;

     WOL_CHECKBOX   =  8;

     WOL_GROUPBOX   =  9;

     WOL_RADIOBUTTON= 10;

     WOL_MEMO       = 11;

     WOL_SCROLLBAR  = 12;



     WOL_MAINWINDOW = 14;



     {WOL Events flags - may be enumeration (trying - see above)}



     {Events for WOL manipulation}

     WOL_WM_DESTROY    = WM_USER + 100;

     WOL_WM_CLOSE      = WM_USER + 101;

     WOL_WM_BEGINMODAL = WM_USER + 102;

     WOL_WM_ENDMODAL   = WM_USER + 103;



     {WOL default styles for objects - using internal}

     //WINDefaultStyle      = WS_OVERLAPPEDWINDOW or WS_CHILD or WS_GROUP or WS_TABSTOP;

     WINDefaultStyle      = WS_OVERLAPPEDWINDOW or WS_GROUP or WS_TABSTOP;

     NormalWinDefaulStyle = WS_CAPTION or WS_THICKFRAME or WS_MINIMIZEBOX or WS_MAXIMIZEBOX or WS_SYSMENU;

     MDIDefaultStyle      = WS_CHILD or WS_VISIBLE or WS_GROUP or WS_TABSTOP or WS_CAPTION or WS_CLIPCHILDREN or WS_HSCROLL or WS_VSCROLL or WS_CLIPSIBLINGS or MDIS_ALLCHILDSTYLES;

     MDIDefaultExStyle    = WS_EX_CLIENTEDGE;

     NewControlStyle      = WS_EX_CLIENTEDGE;

     MainDefaultStyle     = WS_OVERLAPPED or WS_CAPTION or WS_BORDER or WS_THICKFRAME or WS_MAXIMIZEBOX or WS_MINIMIZEBOX or {WS_CLIPCHILDREN or} WS_VISIBLE or WS_SYSMENU or WS_GROUP or WS_TABSTOP;

     MainDefaultExStyle   = WS_EX_CLIENTEDGE or WS_EX_CONTROLPARENT;

     ComboBoxDefaultStyle = WS_CHILDWINDOW or CBS_AUTOHSCROLL or WS_VSCROLL or CBS_DROPDOWN or CBS_HASSTRINGS or WS_BORDER or WS_TABSTOP or CBS_OEMCONVERT;

     ListBoxDefaultStyle  = WS_CHILDWINDOW or LBS_NOINTEGRALHEIGHT or LBS_HASSTRINGS or WS_BORDER or WS_TABSTOP or LBS_STANDARD;

     ButtonDefaultStyle   = WS_CHILDWINDOW or WS_VISIBLE or BS_PUSHLIKE or BS_TEXT or WS_TABSTOP or BS_NOTIFY or BS_CENTER or BS_VCENTER;

     ButtonDefaultStyleD  = ButtonDefaultStyle or BS_DEFPUSHBUTTON or WS_BORDER;

     LabelDefaultStyle    = WS_CHILDWINDOW or WS_VISIBLE or SS_LEFT or SS_NOTIFY;

     EditDefaultStyle     = WS_CHILDWINDOW or WS_VISIBLE or ES_LEFT or WS_BORDER or ES_AUTOHSCROLL or WS_TABSTOP;

     GroupBoxDefaultStyle = WS_CHILDWINDOW or WS_VISIBLE or BS_GROUPBOX or WS_CLIPSIBLINGS or WS_CLIPCHILDREN or WS_TABSTOP or WS_GROUP;

     CheckBoxDefaultStyle = WS_CHILDWINDOW or WS_VISIBLE or BS_AUTOCHECKBOX or WS_TABSTOP or BS_NOTIFY;

     RButtonDefaultStyle  = WS_CHILDWINDOW or WS_TABSTOP or BS_AUTORADIOBUTTON or BS_NOTIFY;

     MemoDefaultStyle     = WS_CHILDWINDOW or WS_VISIBLE or ES_LEFT or ES_AUTOHSCROLL or ES_AUTOVSCROLL or ES_MULTILINE or WS_TABSTOP or ES_WANTRETURN;

     ScrollBarDefStyle    = WS_CHILDWINDOW or WS_VISIBLE or SBS_HORZ;



     crNone        =  0;

     crDefault     = -1;

     crArrow       = -2;

     crCross       = -3;

     crIBeam       = -4;

     crSize        = -5;

     crSizeNESW    = -6;

     crSizeNS      = -7;

     crSizeNWSE    = -8;

     crSizeWE      = -9;

     crUpArrow     = -10;

     crHourGlass   = -11;

     crDrag        = -12;

     crNoDrop      = -13;

     crHSplit      = -14;

     crVSplit      = -15;

     crMultiDrag   = -16;

     crSQLWait     = -17;

     crNo          = -18;

     crAppStart    = -19;

     crHelp        = -20;

     crHandPoint   = -21;



     {Colors for FreePascal with Delphi's names}

     

     clScrollBar           = TColor(COLOR_SCROLLBAR or $80000000);

     clBackground          = TColor(COLOR_BACKGROUND or $80000000);

     clActiveCaption       = TColor(COLOR_ACTIVECAPTION or $80000000);

     clInactiveCaption     = TColor(COLOR_INACTIVECAPTION or $80000000);

     clMenu                = TColor(COLOR_MENU or $80000000);

     clWindow              = TColor(COLOR_WINDOW or $80000000);

     clWindowFrame         = TColor(COLOR_WINDOWFRAME or $80000000);

     clMenuText            = TColor(COLOR_MENUTEXT or $80000000);

     clWindowText          = TColor(COLOR_WINDOWTEXT or $80000000);

     clCaptionText         = TColor(COLOR_CAPTIONTEXT or $80000000);

     clActiveBorder        = TColor(COLOR_ACTIVEBORDER or $80000000);

     clInactiveBorder      = TColor(COLOR_INACTIVEBORDER or $80000000);

     clAppWorkSpace        = TColor(COLOR_APPWORKSPACE or $80000000);

     clHighlight           = TColor(COLOR_HIGHLIGHT or $80000000);

     clHighlightText       = TColor(COLOR_HIGHLIGHTTEXT or $80000000);

     clBtnFace             = TColor(COLOR_BTNFACE or $80000000);

     clBtnShadow           = TColor(COLOR_BTNSHADOW or $80000000);

     clGrayText            = TColor(COLOR_GRAYTEXT or $80000000);

     clBtnText             = TColor(COLOR_BTNTEXT or $80000000);

     clInactiveCaptionText = TColor(COLOR_INACTIVECAPTIONTEXT or $80000000);

     clBtnHighlight        = TColor(COLOR_BTNHIGHLIGHT or $80000000);

     cl3DDkShadow          = TColor(COLOR_3DDKSHADOW or $80000000);

     cl3DLight             = TColor(COLOR_3DLIGHT or $80000000);

     clInfoText            = TColor(COLOR_INFOTEXT or $80000000);

     clInfoBk              = TColor(COLOR_INFOBK or $80000000);

   

     clBlack               = TColor($000000);

     clMaroon              = TColor($000080);

     clGreen               = TColor($008000);

     clOlive               = TColor($008080);

     clNavy                = TColor($800000);

     clPurple              = TColor($800080);

     clTeal                = TColor($808000);

     clGray                = TColor($808080);

     clSilver              = TColor($C0C0C0);

     clRed                 = TColor($0000FF);

     clLime                = TColor($00FF00);

     clYellow              = TColor($00FFFF);

     clBlue                = TColor($FF0000);

     clFuchsia             = TColor($FF00FF);

     clAqua                = TColor($FFFF00);

     clLtGray              = TColor($C0C0C0);

     clDkGray              = TColor($808080);

     clWhite               = TColor($FFFFFF);

     clNone                = TColor($1FFFFFFF);

     clDefault             = TColor($20000000);



     {Problem with common dialogs}

     WMWOL_CLOSEDIALOG = WM_USER+15;



type



    T_RECT           = {$Include WINDEF.inc}.TRect;

    P_RECT           = {$Include WINDEF.inc}.PRect;

    T_POINT          = {$Include WINDEF.inc}.TPoint;

    P_POINT          = {$Include WINDEF.inc}.PPoint;

    TRECT            = {$Include WINDEF.inc}.TRect;

    PRECT            = {$Include WINDEF.inc}.PRect;



    {WOL objects events}

    TWOL_EventProc   = procedure (Sender:THandle);

    TWOL_PeekMsg     = procedure (var Msg:TMSG; var Handled:Boolean);

    TWOL_IdleEvent   = procedure (Win:THandle; var Done:Boolean);



    {WOL objects styles flags}

    TAWOLBorderIcon  = ( wol_biClose,

                         wol_biMinimize,

                         wol_biMaximize,

                         wol_biHelp );



    TWOL_BorderIcon   = set of TAWOLBorderIcon;



    TWOL_WindowStyle = ( wol_wsNormal,

                         wol_wsMDIChild,

                         wol_wsMDIForm,

                         wol_wsAlwaysOnTop );



    TWOL_BorderStyle = ( wol_bsNone,

                         wol_bsSingle,

                         wol_bsSizeable,

                         wol_bsDialog,

                         wol_bsTooWindow,

                         wol_bsSizeTooWin );



    TAWOL_CharCase   = ( wol_ecNormal,

                         wol_ecLowerCase,

                         wol_ecUpperCase );



    TWOL_Alignment   = ( wol_taCenter,

                         wol_taLeftJustify,

                         wol_taRightJustify );



    TWOL_ComboStyle  = ( wol_csDropDown,

                         wol_csSimple,

                         wol_csDropDownList,

                         wol_csOwnerDrawFixed,

                         wol_csOwnerDrawVariable );



    TAWOL_FlagStyle  = ( wol_csSort,

                         wol_csComboDropDrawList );



    TWOL_FlagStyle   = set of TAWOL_FlagStyle;



    {Key State}

    TWOL_ShiftState = set of ( wol_ssShift,

                               wol_ssAlt,

                               wol_ssCtrl,

                               wol_ssLeft,

                               wol_ssRight,

                               wol_ssMiddle,

                               wol_ssDouble );



    {WOL events used in ExecuteEvento}

    TWOL_Events      = ( wol_None,

                         wol_OnDraw,

                         wol_OnClose,

                         wol_OnCreate,

                         wol_OnClick,

                         wol_OnDoubleClick,

                         wol_OnKeyDown,

                         wol_OnKeyUp,

                         wol_OnDestroy,

                         wol_OnGetFocus,

                         wol_OnLoseFocus,

                         wol_OnResize,

                         wol_OnMouseUp,

                         wol_OnMouseDown,

                         wol_OnMouseMove,



                         wol_OnMaximize,

                         wol_OnMinimize,

                         wol_OnRestore,

                         wol_OnScroll);



    {$IFDEF FPC}

    PMessage = ^TMessage;

    TMessage = record

                 Msg   : Word;

                 case Integer of

                      0: ( WParam  : WPARAM;

                           LParam  : LPARAM;

                           Result  : Longint );

                      1: ( WParamLo: Word;

                           WParamHi: Word;

                           LParamLo: Word;

                           LParamHi: Word;

                           ResultLo: Word;

                           ResultHi: Word );

               end;



    TWMWindowPosChanged = record

      Msg: Cardinal;

      Unused: Integer;

      WindowPos: PWindowPos;

      Result: Longint;

    end;



    TWMPaint = record

      Msg: Cardinal;

      DC: HDC;

      Unused: Longint;

      Result: Longint;

    end;



   TWMKey = record

      Msg: Cardinal;

      CharCode: Word;

      Unused: Word;

      KeyData: Longint;

      Result: Longint;

    end;

    {$ENDIF}



    TCreateParams = record

                      Caption     : PChar;

                      Style       : Longint;

                      ExStyle     : Longint;

                      X,

                      Y,

                      Width,

                      Height      : Integer;

                      WndParent   : HWnd;

                      hInstance   : THandle;

                      Background  : HBRUSH;

                      hCursor     : HCURSOR;

                      WndProc     : Pointer;

                      Param       : Pointer;

                      WindowClass : TWndClass;

                      WinClassName: array[0..63] of Char;

                    end;



    TControlStyle = set of ( csAcceptsControls,

                             csCaptureMouse,

                             csDesignInteractive,

                             csFramed,

                             csClickEvents,

                             csSetCaption,

                             csOpaque,

                             csDoubleClicks,

                             csFixedWidth,

                             csFixedHeight,

                             csNoDesignVisible,

                             csReplicatable,

                             csNoStdEvents,

                             csDisplayDragImage,

                             csReflector );



    THelpContext     = Integer;

    TShiftState      = set of (ssShift, ssAlt, ssCtrl, ssLeft, ssRight, ssMiddle, ssDouble);

    TMouseButton     = (mbLeft, mbRight, mbMiddle);

    TFillStyle       = (fsSurface, fsBorder);

    TWindowState     = (wsNormal, wsMinimized, wsMaximized);

    TBorderIcons     = set of (biSystemMenu, biMinimize, biMaximize, biHelp);

    TFormBorderStyle = (bsNone, bsSingle, bsSizeable, bsDialog, bsToolWindow, bsSizeToolWin);

    TBorderStyle     = bsNone..bsSingle;

    TShowAction      = (saIgnore, saRestore, saMinimize, saMaximize);

    TFormStyle       = (fsNormal, fsMDIChild, fsMDIForm, fsStayOnTop);

    TPosition        = (poDesigned, poDefault, poDefaultPosOnly, poDefaultSizeOnly, poScreenCenter);

    TTileMode        = (tbHorizontal, tbVertical);

    TFormState       = set of (fsCreating, fsVisible, fsShowing, fsModal, fsCreatedMDIChild);

    TPrintScale      = (poNone, poProportional, poPrintToFit);

    TModalResult     = Low(Integer)..High(Integer);

    TCloseAction     = (caNone, caHide, caFree, caMinimize);

    TProgressStage   = (psStarting, psRunning, psEnding);



    TNotifyEventA    = procedure(Sender:TObject) of object;

    TWndMethod       = procedure(var Message: TMessage) of object;

    TWOLMouseEvent   = procedure(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer) {$IFDEF PROCDOOBJ} of object {$ENDIF};

    TMouseMoveEvent  = procedure(Sender: TObject; Shift: TShiftState; X, Y: Integer) {$IFDEF PROCDOOBJ} of object {$ENDIF};

    TNotifyEvent     = procedure(Sender:TObject) {$IFDEF PROCDOOBJ} of object {$ENDIF};

    TExceptionEvent  = procedure(Sender: TObject) {$IFDEF PROCDOOBJ} of object {$ENDIF};

    TMessageEvent    = procedure(var Msg: TMsg; var Handled: Boolean) {$IFDEF PROCDOOBJ} of object {$ENDIF};

    TIdleEvent       = procedure(Sender: TObject; var Done: Boolean) {$IFDEF PROCDOOBJ} of object {$ENDIF};

    TShowHintEvent   = procedure(var HintStr: string; var CanShow: Boolean) {$IFDEF PROCDOOBJ} of object {$ENDIF};

    TWindowHook      = function(var Message: TMessage): Boolean of object;

    THelpEvent       = function(Command: Word; Data: Longint; var CallHelp: Boolean): Boolean {$IFDEF PROCDOOBJ} of object {$ENDIF};

    TCloseEvent      = procedure(Sender: TObject; var Action: TCloseAction) {$IFDEF PROCDOOBJ} of object {$ENDIF};

    TCloseQueryEvent = procedure(Sender: TObject; var CanClose: Boolean) {$IFDEF PROCDOOBJ} of object {$ENDIF};

    TProgressEvent   = procedure (Sender:TObject; Stage:TProgressStage; PercentDone:Byte; RedrawNow:Boolean; const R:TRect; const Msg:string) {$IFDEF PROCDOOBJ}of object{$ENDIF};

    TProgressEventA  = procedure (Sender:TObject; Stage:TProgressStage; PercentDone:Byte; RedrawNow:Boolean; const R:TRect; const Msg:string) of object;



    TIcon            = Integer;

    TWOLColor        = TColor;





    {Hooks Procedure Record}

    PHookRecord = ^THookRecord;

    THookRecord = record

                    Ponteiro:TWindowHook;

                    Numero  :Integer;

                  end;





function GetWindowsCursor(Handle:HWND; Value:HCURSOR):HCURSOR;

function Win32Platform:DWORD;

function Rect(x,y,w,h:Integer):T_RECT;

function MAKEPOINTS(L:DWORD):T_POINT;



implementation

uses wolDBG;



procedure ResetCursor(Handle:HWND);

var Codigo:Longint;

    P     :T_POINT;

    H     :HWND;

begin

  if Handle = 0 then Exit;

  GetCursorPos(P);

  H:=WindowFromPoint(P);

  if (H = Handle) and (GetWindowThreadProcessId(Handle, nil) = GetCurrentThreadId) then begin

     Codigo:=SendMessage(Handle, WM_NCHITTEST, P.X, P.Y);

     SendMessage(Handle, WM_SETCURSOR, Handle, MakeLong(Codigo, WM_MOUSEMOVE));

  end;

end;



function GetWindowsCursor(Handle:HWND; Value:HCURSOR):HCURSOR;

begin

  Result:=0;

  case Value of

       crNone        : Result:=LoadCursor(0, #0);

       crDefault     : begin

                         Result:=LoadCursor(0, IDC_ARROW);

                         ResetCursor(Handle);

                       end;

       crArrow       : Result:=LoadCursor(0, IDC_ARROW);

       crCross       : Result:=LoadCursor(0, IDC_CROSS);

       crIBeam       : Result:=LoadCursor(0, IDC_IBEAM);

       crSize        : Result:=LoadCursor(0, IDC_SIZEALL);

       crSizeNESW    : Result:=LoadCursor(0, IDC_SIZENESW);

       crSizeNS      : Result:=LoadCursor(0, IDC_SIZENS);

       crSizeNWSE    : Result:=LoadCursor(0, IDC_SIZENWSE);

       crSizeWE      : Result:=LoadCursor(0, IDC_SIZEWE);

       crUpArrow     : Result:=LoadCursor(0, IDC_UPARROW);

       crHourGlass   : Result:=LoadCursor(0, IDC_WAIT);

       crDrag        : Result:=LoadCursor(0, IDC_ARROW);

       crNoDrop      : Result:=LoadCursor(0, IDC_ARROW);

       crHSplit      : Result:=LoadCursor(0, IDC_ARROW);

       crVSplit      : Result:=LoadCursor(0, IDC_ARROW);

       crMultiDrag   : Result:=LoadCursor(0, IDC_ARROW);

       crSQLWait     : Result:=LoadCursor(0, IDC_ARROW);

       crNo          : Result:=LoadCursor(0, IDC_NO);

       crAppStart    : Result:=LoadCursor(0, IDC_APPSTARTING);

       crHelp        : Result:=LoadCursor(0, IDC_HELP);

       crHandPoint   : Result:=LoadCursor(0, IDC_ARROW);

  end;

end;



function Win32Platform:DWORD;

var osvi:TOSVERSIONINFO;

begin

  FillChar(osvi, 0, sizeof(TOSVERSIONINFO));

  osvi.dwOSVersionInfoSize:=sizeof(TOSVERSIONINFO);

  GetVersionEx(osvi);

  Result:=osvi.dwPlatformId;

end;



function Rect(x,y,w,h:Integer):T_RECT;

begin

  Result.Left  :=x;

  Result.Top   :=y;

  Result.Right :=w;

  Result.Bottom:=h;

end;



function MAKEPOINTS(L:DWORD):T_POINT;

begin

  Result.X:=LOWORD(L);

  Result.Y:=HIWORD(L);

end;



{$IFDef Win32}

initialization

  WOL_Instance:=HInstance;

{$EndIF}

end.



{***********************************************************************}

{                            FILE HISTORY                               }

{***********************************************************************}

{Version .2 (Carlos Alberto de Oliveira, jun 2-6 2001)                  }

{                                                                       }

{  1.) Changed wolColor unit to wolDefs                                 }

{  2.) Moved several definitions to unit                                }

{***********************************************************************}

{Version .5 (Carlos Alberto de Oliveira, jul 11 2001)                   }

{                                                                       }

{  1.) Changed Color Constants to improvement call to color properties  }

{  2.) Changed TMessage record to more compatibility with Delphi        }

{  3.) Changed Color Constants to make more Delphi compatible           }

{  4.) Removed WOL_clColor function                                     }

{  5.) Added Win32Platform function                                     }

{  6.) Added Rect function                                              }

{***********************************************************************}

{Version .6 (Carlos Alberto de Oliveira, jul 11 2001)                   }

{                                                                       }

{  1.) Added MAKEPOINTS function to replace macro missing in Windows.pp }

{                                                                       }

{Version .6 (Andrew Johnson, Aug 22 2001)                               }

{                                                                       }

{  1.) Added compiler directives for GTK.                               }

{  2.) Added PMessage.                                                  }

{  3.) Added compiler directive for non-win32                           }

{***********************************************************************}



